Docs
CodeRabbit
Cloudflare
Railway
Netlify
AG Grid
WorkOS
Clerk
OpenRouter
SerpAPI
Prisma
Electric
Sentry
Unkey
CodeRabbit
Cloudflare
Railway
Netlify
AG Grid
WorkOS
Clerk
OpenRouter
SerpAPI
Prisma
Electric
Sentry
Unkey
Table API Reference
Column API Reference
Row API Reference
Cell API Reference
Header API Reference
Features API Reference
Static Functions API Reference

Solid Example: Kitchen Sink

import { faker } from '@faker-js/faker'
import {
  aggregationFns,
  createExpandedRowModel,
  createFacetedMinMaxValues,
  createFacetedRowModel,
  createFacetedUniqueValues,
  createFilteredRowModel,
  createGroupedRowModel,
  createPaginatedRowModel,
  createSortedRowModel,
  createTableHook,
  filterFns,
  sortFns,
  stockFeatures,
} from '@tanstack/solid-table'
import { useTanStackTableDevtools } from '@tanstack/solid-table-devtools'
import { compareItems, rankItem } from '@tanstack/match-sorter-utils'
import {
  For,
  createEffect,
  createMemo,
  createSignal,
  onCleanup,
} from 'solid-js'
import { makeData } from './makeData'
import type { JSX } from 'solid-js'
import type { RankingInfo } from '@tanstack/match-sorter-utils'
import type { Person } from './makeData'
import type {
  Cell,
  CellData,
  Column,
  FilterFn,
  Header,
  Row,
  RowData,
  SortFn,
  TableFeatures,
} from '@tanstack/solid-table'

declare module '@tanstack/solid-table' {
  interface ColumnMeta<
    TFeatures extends TableFeatures,
    TData extends RowData,
    TValue extends CellData = CellData,
  > {
    filterVariant?: 'text' | 'range' | 'select'
  }
  interface FilterFns {
    fuzzy: FilterFn<typeof stockFeatures, Person>
  }
  interface FilterMeta {
    itemRank?: RankingInfo
  }
}

const { createAppTable, createAppColumnHelper } = createTableHook({
  features: stockFeatures,
  rowModels: {
    expandedRowModel: createExpandedRowModel(),
    filteredRowModel: createFilteredRowModel({
      ...filterFns,
      fuzzy: (row, columnId, value, addMeta) => {
        const itemRank = rankItem(row.getValue(columnId), value)
        addMeta?.({ itemRank })
        return itemRank.passed
      },
    }),
    facetedRowModel: createFacetedRowModel(),
    facetedMinMaxValues: createFacetedMinMaxValues(),
    facetedUniqueValues: createFacetedUniqueValues(),
    groupedRowModel: createGroupedRowModel(aggregationFns),
    paginatedRowModel: createPaginatedRowModel(),
    sortedRowModel: createSortedRowModel(sortFns),
  },
})

const fuzzySort: SortFn<typeof stockFeatures, Person> = (
  rowA,
  rowB,
  columnId,
) => {
  let dir = 0
  if (rowA.columnFiltersMeta[columnId]) {
    dir = compareItems(
      rowA.columnFiltersMeta[columnId].itemRank!,
      rowB.columnFiltersMeta[columnId].itemRank!,
    )
  }
  return dir === 0 ? sortFns.alphanumeric(rowA, rowB, columnId) : dir
}

const sortStatusFn: SortFn<typeof stockFeatures, Person> = (rowA, rowB) => {
  const statusOrder = ['single', 'complicated', 'relationship']
  return (
    statusOrder.indexOf(rowA.original.status) -
    statusOrder.indexOf(rowB.original.status)
  )
}

const getCommonPinningStyles = (
  column: Column<typeof stockFeatures, Person>,
): JSX.CSSProperties => {
  const isPinned = column.getIsPinned()
  const isLastLeftPinnedColumn =
    isPinned === 'left' && column.getIsLastColumn('left')
  const isFirstRightPinnedColumn =
    isPinned === 'right' && column.getIsFirstColumn('right')

  return {
    'box-shadow': isLastLeftPinnedColumn
      ? '-4px 0 4px -4px gray inset'
      : isFirstRightPinnedColumn
        ? '4px 0 4px -4px gray inset'
        : undefined,
    left: isPinned === 'left' ? `${column.getStart('left')}px` : undefined,
    right: isPinned === 'right' ? `${column.getAfter('right')}px` : undefined,
    opacity: isPinned ? 0.97 : 1,
    position: isPinned ? 'sticky' : 'relative',
    'z-index': isPinned ? 1 : 0,
  }
}

function IndeterminateCheckbox(
  props: {
    indeterminate?: boolean
  } & JSX.InputHTMLAttributes<HTMLInputElement>,
) {
  let ref!: HTMLInputElement
  createEffect(() => {
    if (typeof props.indeterminate === 'boolean') {
      ref.indeterminate = !props.checked && props.indeterminate
    }
  })

  return <input type="checkbox" ref={ref} {...props} />
}

function DebouncedInput(
  props: {
    value: string | number
    onChange: (value: string | number) => void
    debounce?: number
  } & Omit<JSX.InputHTMLAttributes<HTMLInputElement>, 'onChange' | 'value'>,
) {
  const [value, setValue] = createSignal(props.value)

  createEffect(() => {
    setValue(props.value)
  })

  createEffect(() => {
    const currentValue = value()
    const timeout = setTimeout(
      () => props.onChange(currentValue),
      props.debounce ?? 300,
    )
    onCleanup(() => clearTimeout(timeout))
  })

  return (
    <input
      {...props}
      value={value()}
      onInput={(e) => setValue(e.currentTarget.value)}
    />
  )
}

function Filter(props: { column: Column<typeof stockFeatures, Person> }) {
  const filterVariant = () => props.column.columnDef.meta?.filterVariant
  const sortedUniqueValues = createMemo(() =>
    filterVariant() === 'range'
      ? []
      : Array.from(props.column.getFacetedUniqueValues().keys())
          .sort()
          .slice(0, 5000),
  )

  return (
    <>
      {filterVariant() === 'range' ? (
        <div class="filter-row">
          <DebouncedInput
            type="number"
            min={Number(props.column.getFacetedMinMaxValues()?.[0] ?? '')}
            max={Number(props.column.getFacetedMinMaxValues()?.[1] ?? '')}
            value={
              (
                props.column.getFilterValue() as [number, number] | undefined
              )?.[0] ?? ''
            }
            onChange={(value) =>
              props.column.setFilterValue(
                (old: [number, number] | undefined) => [value, old?.[1]],
              )
            }
            placeholder={`Min${
              props.column.getFacetedMinMaxValues()?.[0] !== undefined
                ? ` (${props.column.getFacetedMinMaxValues()?.[0]})`
                : ''
            }`}
            class="filter-input"
          />
          <DebouncedInput
            type="number"
            min={Number(props.column.getFacetedMinMaxValues()?.[0] ?? '')}
            max={Number(props.column.getFacetedMinMaxValues()?.[1] ?? '')}
            value={
              (
                props.column.getFilterValue() as [number, number] | undefined
              )?.[1] ?? ''
            }
            onChange={(value) =>
              props.column.setFilterValue(
                (old: [number, number] | undefined) => [old?.[0], value],
              )
            }
            placeholder={`Max${
              props.column.getFacetedMinMaxValues()?.[1] !== undefined
                ? ` (${props.column.getFacetedMinMaxValues()?.[1]})`
                : ''
            }`}
            class="filter-input"
          />
        </div>
      ) : filterVariant() === 'select' ? (
        <select
          onChange={(e) => props.column.setFilterValue(e.currentTarget.value)}
          value={(props.column.getFilterValue() ?? '').toString()}
          class="filter-select"
        >
          <option value="">All</option>
          <For each={sortedUniqueValues()}>
            {(value) => <option value={String(value)}>{String(value)}</option>}
          </For>
        </select>
      ) : (
        <>
          <datalist id={props.column.id + 'list'}>
            <For each={sortedUniqueValues()}>
              {(value) => <option value={String(value)} />}
            </For>
          </datalist>
          <DebouncedInput
            type="text"
            value={(props.column.getFilterValue() ?? '') as string}
            onChange={(value) => props.column.setFilterValue(value)}
            placeholder={`Search (${props.column.getFacetedUniqueValues().size})`}
            class="filter-select"
            list={props.column.id + 'list'}
          />
        </>
      )}
    </>
  )
}

type AppTable = ReturnType<typeof createAppTable<Person>>

function TableHeader(props: {
  header: Header<typeof stockFeatures, Person, unknown>
  table: AppTable
}) {
  const column = () => props.header.column
  const style = () => ({
    ...getCommonPinningStyles(column()),
    'white-space': 'nowrap',
    width: `calc(var(--header-${props.header.id}-size) * 1px)`,
  })

  return (
    <th style={style()} colSpan={props.header.colSpan}>
      {!props.header.isPlaceholder ? (
        <>
          <div class="header-row">
            <div style={{ flex: 1, 'min-width': 0 }}>
              <div class="header-controls">
                {column().getCanPin() ? (
                  <span class="pin-actions">
                    {column().getIsPinned() !== 'left' ? (
                      <button
                        class="pin-button"
                        onClick={() => column().pin('left')}
                      >
                        {'<'}
                      </button>
                    ) : null}
                    {column().getIsPinned() ? (
                      <button
                        class="pin-button"
                        onClick={() => column().pin(false)}
                      >
                        x
                      </button>
                    ) : null}
                    {column().getIsPinned() !== 'right' ? (
                      <button
                        class="pin-button"
                        onClick={() => column().pin('right')}
                      >
                        {'>'}
                      </button>
                    ) : null}
                  </span>
                ) : null}
                {column().getCanGroup() ? (
                  <button
                    class="pin-button"
                    onClick={column().getToggleGroupingHandler()}
                  >
                    {column().getIsGrouped()
                      ? `Stop (${column().getGroupedIndex()})`
                      : 'Group'}
                  </button>
                ) : null}
              </div>
              {column().getCanSort() ? (
                <span
                  class="sortable-header"
                  onClick={column().getToggleSortingHandler()}
                >
                  <props.table.FlexRender header={props.header} />
                  {{
                    asc: ' â–²',
                    desc: ' â–¼',
                  }[column().getIsSorted() as string] ?? null}
                </span>
              ) : (
                <props.table.FlexRender header={props.header} />
              )}
              {column().getCanFilter() ? (
                <div>
                  <Filter column={column()} />
                </div>
              ) : null}
            </div>
          </div>
          {column().getCanResize() ? (
            <div
              onDblClick={() => column().resetSize()}
              onMouseDown={props.header.getResizeHandler()}
              onTouchStart={props.header.getResizeHandler()}
              class={`resizer ${column().getIsResizing() ? 'isResizing' : ''}`}
            />
          ) : null}
        </>
      ) : null}
    </th>
  )
}

function TableCell(props: {
  cell: Cell<typeof stockFeatures, Person, unknown>
  table: AppTable
}) {
  const className = () => {
    const groupingActive = props.table.atoms.grouping.get().length > 0
    const hasAggregation = !!props.cell.column.columnDef.aggregationFn
    return !groupingActive
      ? undefined
      : props.cell.getIsGrouped()
        ? 'cell-grouped'
        : hasAggregation && props.cell.getIsAggregated()
          ? 'cell-aggregated'
          : props.cell.getIsPlaceholder()
            ? 'cell-placeholder'
            : undefined
  }

  return (
    <td
      style={{
        ...getCommonPinningStyles(props.cell.column),
        width: `calc(var(--col-${props.cell.column.id}-size) * 1px)`,
      }}
      class={className()}
    >
      {props.cell.getIsGrouped() ? (
        <button
          onClick={props.cell.row.getToggleExpandedHandler()}
          style={{
            cursor: props.cell.row.getCanExpand() ? 'pointer' : 'normal',
          }}
        >
          {props.cell.row.getIsExpanded() ? 'v' : '>'}{' '}
          <props.table.FlexRender cell={props.cell} /> (
          {props.cell.row.subRows.length.toLocaleString()})
        </button>
      ) : (
        <props.table.FlexRender cell={props.cell} />
      )}
    </td>
  )
}

function PinnedRow(props: {
  row: Row<typeof stockFeatures, Person>
  table: AppTable
}) {
  const bottomRows = () => props.table.getBottomRows()
  return (
    <tr
      class="pinned-row"
      style={{
        position: 'sticky',
        top:
          props.row.getIsPinned() === 'top'
            ? `${props.row.getPinnedIndex() * 32 + 48}px`
            : undefined,
        bottom:
          props.row.getIsPinned() === 'bottom'
            ? `${(bottomRows().length - 1 - props.row.getPinnedIndex()) * 32}px`
            : undefined,
        'z-index': 1,
      }}
    >
      <For each={props.row.getVisibleCells()}>
        {(cell) => <TableCell cell={cell} table={props.table} />}
      </For>
    </tr>
  )
}

const columnHelper = createAppColumnHelper<Person>()

const columns = columnHelper.columns([
  columnHelper.display({
    id: 'select',
    size: 80,
    minSize: 80,
    maxSize: 80,
    enableSorting: false,
    enableGrouping: false,
    enableHiding: false,
    enableResizing: false,
    header: ({ table }) => (
      <IndeterminateCheckbox
        checked={table.getIsAllPageRowsSelected()}
        indeterminate={table.getIsSomePageRowsSelected()}
        onChange={table.getToggleAllPageRowsSelectedHandler()}
        title="Select all on this page"
      />
    ),
    cell: ({ row }) => (
      <div class="column-toggle-row">
        <IndeterminateCheckbox
          checked={row.getIsSelected()}
          disabled={!row.getCanSelect()}
          indeterminate={row.getIsSomeSelected()}
          onChange={row.getToggleSelectedHandler()}
        />{' '}
        <button
          class="pin-button"
          onClick={() => row.pin(row.getIsPinned() === 'top' ? false : 'top')}
        >
          {row.getIsPinned() === 'top' ? 'Pinned' : 'Pin'}
        </button>
      </div>
    ),
  }),
  columnHelper.accessor('firstName', {
    id: 'firstName',
    size: 200,
    header: 'First Name',
    filterFn: 'fuzzy',
    sortFn: fuzzySort,
    meta: { filterVariant: 'text' },
    getGroupingValue: (row) => `${row.firstName} ${row.lastName}`,
    cell: ({ row, getValue }) => (
      <div style={{ 'padding-left': `${row.depth * 1.5}rem` }}>
        {row.getCanExpand() ? (
          <button
            onClick={row.getToggleExpandedHandler()}
            style={{ cursor: 'pointer', 'margin-right': '0.25rem' }}
          >
            {row.getIsExpanded() ? 'v' : '>'}
          </button>
        ) : (
          <span style={{ 'margin-right': '0.25rem' }}>-</span>
        )}
        {String(getValue())}
      </div>
    ),
  }),
  columnHelper.accessor((row) => row.lastName, {
    id: 'lastName',
    size: 180,
    header: 'Last Name',
    meta: { filterVariant: 'text' },
  }),
  columnHelper.accessor('age', {
    id: 'age',
    size: 200,
    header: 'Age',
    meta: { filterVariant: 'range' },
    aggregationFn: 'median',
    aggregatedCell: ({ getValue }) =>
      Math.round(getValue<number>() * 100) / 100,
  }),
  columnHelper.accessor('visits', {
    id: 'visits',
    size: 200,
    header: 'Visits',
    meta: { filterVariant: 'range' },
    aggregationFn: 'sum',
    aggregatedCell: ({ getValue }) => getValue<number>().toLocaleString(),
  }),
  columnHelper.accessor('status', {
    id: 'status',
    size: 200,
    header: 'Status',
    sortFn: sortStatusFn,
    meta: { filterVariant: 'select' },
  }),
  columnHelper.accessor('progress', {
    id: 'progress',
    size: 200,
    header: 'Profile Progress',
    meta: { filterVariant: 'range' },
    aggregationFn: 'mean',
    cell: ({ getValue }) => `${Math.round(getValue<number>() * 100) / 100}%`,
    aggregatedCell: ({ getValue }) =>
      `${Math.round(getValue<number>() * 100) / 100}%`,
  }),
])

function App() {
  const [data, setData] = createSignal(makeData(1_000))
  const [, setRenderTick] = createSignal({})

  const table = createAppTable(
    {
      key: 'kitchen-sink', // needed for devtools
      columns,
      get data() {
        return data()
      },
      getSubRows: (row) => row.subRows,
      globalFilterFn: 'fuzzy',
      columnResizeMode: 'onChange',
      defaultColumn: { minSize: 200, maxSize: 800 },
      initialState: {
        columnOrder: columns.map((c) => c.id!),
        columnPinning: { left: ['select'], right: [] },
        pagination: { pageIndex: 0, pageSize: 20 },
      },
      keepPinnedRows: true,
      debugTable: true,
    },
    (state) => state,
  )

  useTanStackTableDevtools(table)

  const columnSizeVars = createMemo(() => {
    void table.atoms.columnResizing.get()
    void table.atoms.columnSizing.get()
    const colSizes: Record<string, number> = {}
    for (const header of table.getFlatHeaders()) {
      colSizes[`--header-${header.id}-size`] = header.getSize()
      colSizes[`--col-${header.column.id}-size`] = header.column.getSize()
    }
    return colSizes
  })

  const refreshData = () => setData(makeData(1_000))
  const nestedData = () => setData(makeData(100, 5, 3))
  const stress10k = () => setData(makeData(10_000))
  const stress100k = () => setData(makeData(100_000))
  const shuffleColumns = () => {
    table.setColumnOrder(
      faker.helpers.shuffle(table.getAllLeafColumns().map((d) => d.id)),
    )
  }

  return (
    <div class="demo-root">
      <h1>Kitchen Sink - All Features</h1>
      <div class="toolbar">
        <div class="toolbar-row">
          <DebouncedInput
            value={(table.atoms.globalFilter.get() ?? '') as string}
            onChange={(value) => table.setGlobalFilter(String(value))}
            class="global-filter-input"
            placeholder="Fuzzy search all columns..."
          />
        </div>
        <div class="toolbar-row">
          <button onClick={refreshData} class="demo-button demo-button-sm">
            Flat 1k
          </button>
          <button onClick={nestedData} class="demo-button demo-button-sm">
            Nested 100x5x3
          </button>
          <button onClick={stress10k} class="demo-button demo-button-sm">
            Stress 10k (flat)
          </button>
          <button onClick={stress100k} class="demo-button demo-button-sm">
            Stress 100k (flat)
          </button>
          <button
            onClick={() => table.reset()}
            class="demo-button demo-button-sm"
          >
            Reset Table
          </button>
          <button onClick={shuffleColumns} class="demo-button demo-button-sm">
            Shuffle Columns
          </button>
          <button
            onClick={() => setRenderTick({})}
            class="demo-button demo-button-sm"
          >
            Force Rerender
          </button>
          <span class="nowrap">
            {table.getSelectedRowModel().flatRows.length.toLocaleString()} of{' '}
            {table.getCoreRowModel().flatRows.length.toLocaleString()} selected
          </span>
        </div>
        <details class="column-toggle-panel">
          <summary class="column-toggle-panel-header">
            Column visibility
          </summary>
          <div class="column-toggle-row">
            <label>
              <input
                type="checkbox"
                checked={table.getIsAllColumnsVisible()}
                onChange={table.getToggleAllColumnsVisibilityHandler()}
              />{' '}
              Toggle All
            </label>
          </div>
          <For each={table.getAllLeafColumns()}>
            {(column) => (
              <div class="column-toggle-row">
                <label>
                  <input
                    type="checkbox"
                    checked={column.getIsVisible()}
                    disabled={!column.getCanHide()}
                    onChange={column.getToggleVisibilityHandler()}
                  />{' '}
                  {column.id}
                </label>
              </div>
            )}
          </For>
        </details>
      </div>
      <div class="table-container">
        <table
          style={{ ...columnSizeVars(), width: `${table.getTotalSize()}px` }}
        >
          <thead>
            <For each={table.getHeaderGroups()}>
              {(headerGroup) => (
                <tr>
                  <For each={headerGroup.headers}>
                    {(header) => <TableHeader header={header} table={table} />}
                  </For>
                </tr>
              )}
            </For>
          </thead>
          <tbody>
            <For each={table.getTopRows()}>
              {(row) => <PinnedRow row={row} table={table} />}
            </For>
            <For each={table.getCenterRows()}>
              {(row) => (
                <tr>
                  <For each={row.getVisibleCells()}>
                    {(cell) => <TableCell cell={cell} table={table} />}
                  </For>
                </tr>
              )}
            </For>
            <For each={table.getBottomRows()}>
              {(row) => <PinnedRow row={row} table={table} />}
            </For>
          </tbody>
        </table>
      </div>
      <div class="spacer-sm" />
      <div class="controls">
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.setPageIndex(0)}
          disabled={!table.getCanPreviousPage()}
        >
          {'<<'}
        </button>
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.previousPage()}
          disabled={!table.getCanPreviousPage()}
        >
          {'<'}
        </button>
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.nextPage()}
          disabled={!table.getCanNextPage()}
        >
          {'>'}
        </button>
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.setPageIndex(table.getPageCount() - 1)}
          disabled={!table.getCanNextPage()}
        >
          {'>>'}
        </button>
        <span class="inline-controls">
          <div>Page</div>
          <strong>
            {(table.atoms.pagination.get().pageIndex + 1).toLocaleString()} of{' '}
            {table.getPageCount().toLocaleString()}
          </strong>
        </span>
        <span class="inline-controls">
          | Go to page:
          <input
            type="number"
            min="1"
            max={table.getPageCount()}
            value={table.atoms.pagination.get().pageIndex + 1}
            onInput={(e) => {
              const page = e.currentTarget.value
                ? Number(e.currentTarget.value) - 1
                : 0
              table.setPageIndex(page)
            }}
            class="page-size-input"
          />
        </span>
        <select
          value={table.atoms.pagination.get().pageSize}
          onChange={(e) => table.setPageSize(Number(e.currentTarget.value))}
        >
          <For each={[10, 20, 30, 50, 100]}>
            {(pageSize) => <option value={pageSize}>Show {pageSize}</option>}
          </For>
        </select>
      </div>
      <div class="spacer-sm" />
      <div class="nowrap">
        {table.getRowModel().rows.length.toLocaleString()} rows on this page (
        {table.getFilteredRowModel().rows.length.toLocaleString()} filtered of{' '}
        {table.getCoreRowModel().rows.length.toLocaleString()} total)
      </div>
      <div class="spacer-md" />
      <details>
        <summary>Table state (live)</summary>
        <pre class="state-dump">
          {JSON.stringify(table.store.get(), null, 2)}
        </pre>
      </details>
    </div>
  )
}

export default App
import { faker } from '@faker-js/faker'
import {
  aggregationFns,
  createExpandedRowModel,
  createFacetedMinMaxValues,
  createFacetedRowModel,
  createFacetedUniqueValues,
  createFilteredRowModel,
  createGroupedRowModel,
  createPaginatedRowModel,
  createSortedRowModel,
  createTableHook,
  filterFns,
  sortFns,
  stockFeatures,
} from '@tanstack/solid-table'
import { useTanStackTableDevtools } from '@tanstack/solid-table-devtools'
import { compareItems, rankItem } from '@tanstack/match-sorter-utils'
import {
  For,
  createEffect,
  createMemo,
  createSignal,
  onCleanup,
} from 'solid-js'
import { makeData } from './makeData'
import type { JSX } from 'solid-js'
import type { RankingInfo } from '@tanstack/match-sorter-utils'
import type { Person } from './makeData'
import type {
  Cell,
  CellData,
  Column,
  FilterFn,
  Header,
  Row,
  RowData,
  SortFn,
  TableFeatures,
} from '@tanstack/solid-table'

declare module '@tanstack/solid-table' {
  interface ColumnMeta<
    TFeatures extends TableFeatures,
    TData extends RowData,
    TValue extends CellData = CellData,
  > {
    filterVariant?: 'text' | 'range' | 'select'
  }
  interface FilterFns {
    fuzzy: FilterFn<typeof stockFeatures, Person>
  }
  interface FilterMeta {
    itemRank?: RankingInfo
  }
}

const { createAppTable, createAppColumnHelper } = createTableHook({
  features: stockFeatures,
  rowModels: {
    expandedRowModel: createExpandedRowModel(),
    filteredRowModel: createFilteredRowModel({
      ...filterFns,
      fuzzy: (row, columnId, value, addMeta) => {
        const itemRank = rankItem(row.getValue(columnId), value)
        addMeta?.({ itemRank })
        return itemRank.passed
      },
    }),
    facetedRowModel: createFacetedRowModel(),
    facetedMinMaxValues: createFacetedMinMaxValues(),
    facetedUniqueValues: createFacetedUniqueValues(),
    groupedRowModel: createGroupedRowModel(aggregationFns),
    paginatedRowModel: createPaginatedRowModel(),
    sortedRowModel: createSortedRowModel(sortFns),
  },
})

const fuzzySort: SortFn<typeof stockFeatures, Person> = (
  rowA,
  rowB,
  columnId,
) => {
  let dir = 0
  if (rowA.columnFiltersMeta[columnId]) {
    dir = compareItems(
      rowA.columnFiltersMeta[columnId].itemRank!,
      rowB.columnFiltersMeta[columnId].itemRank!,
    )
  }
  return dir === 0 ? sortFns.alphanumeric(rowA, rowB, columnId) : dir
}

const sortStatusFn: SortFn<typeof stockFeatures, Person> = (rowA, rowB) => {
  const statusOrder = ['single', 'complicated', 'relationship']
  return (
    statusOrder.indexOf(rowA.original.status) -
    statusOrder.indexOf(rowB.original.status)
  )
}

const getCommonPinningStyles = (
  column: Column<typeof stockFeatures, Person>,
): JSX.CSSProperties => {
  const isPinned = column.getIsPinned()
  const isLastLeftPinnedColumn =
    isPinned === 'left' && column.getIsLastColumn('left')
  const isFirstRightPinnedColumn =
    isPinned === 'right' && column.getIsFirstColumn('right')

  return {
    'box-shadow': isLastLeftPinnedColumn
      ? '-4px 0 4px -4px gray inset'
      : isFirstRightPinnedColumn
        ? '4px 0 4px -4px gray inset'
        : undefined,
    left: isPinned === 'left' ? `${column.getStart('left')}px` : undefined,
    right: isPinned === 'right' ? `${column.getAfter('right')}px` : undefined,
    opacity: isPinned ? 0.97 : 1,
    position: isPinned ? 'sticky' : 'relative',
    'z-index': isPinned ? 1 : 0,
  }
}

function IndeterminateCheckbox(
  props: {
    indeterminate?: boolean
  } & JSX.InputHTMLAttributes<HTMLInputElement>,
) {
  let ref!: HTMLInputElement
  createEffect(() => {
    if (typeof props.indeterminate === 'boolean') {
      ref.indeterminate = !props.checked && props.indeterminate
    }
  })

  return <input type="checkbox" ref={ref} {...props} />
}

function DebouncedInput(
  props: {
    value: string | number
    onChange: (value: string | number) => void
    debounce?: number
  } & Omit<JSX.InputHTMLAttributes<HTMLInputElement>, 'onChange' | 'value'>,
) {
  const [value, setValue] = createSignal(props.value)

  createEffect(() => {
    setValue(props.value)
  })

  createEffect(() => {
    const currentValue = value()
    const timeout = setTimeout(
      () => props.onChange(currentValue),
      props.debounce ?? 300,
    )
    onCleanup(() => clearTimeout(timeout))
  })

  return (
    <input
      {...props}
      value={value()}
      onInput={(e) => setValue(e.currentTarget.value)}
    />
  )
}

function Filter(props: { column: Column<typeof stockFeatures, Person> }) {
  const filterVariant = () => props.column.columnDef.meta?.filterVariant
  const sortedUniqueValues = createMemo(() =>
    filterVariant() === 'range'
      ? []
      : Array.from(props.column.getFacetedUniqueValues().keys())
          .sort()
          .slice(0, 5000),
  )

  return (
    <>
      {filterVariant() === 'range' ? (
        <div class="filter-row">
          <DebouncedInput
            type="number"
            min={Number(props.column.getFacetedMinMaxValues()?.[0] ?? '')}
            max={Number(props.column.getFacetedMinMaxValues()?.[1] ?? '')}
            value={
              (
                props.column.getFilterValue() as [number, number] | undefined
              )?.[0] ?? ''
            }
            onChange={(value) =>
              props.column.setFilterValue(
                (old: [number, number] | undefined) => [value, old?.[1]],
              )
            }
            placeholder={`Min${
              props.column.getFacetedMinMaxValues()?.[0] !== undefined
                ? ` (${props.column.getFacetedMinMaxValues()?.[0]})`
                : ''
            }`}
            class="filter-input"
          />
          <DebouncedInput
            type="number"
            min={Number(props.column.getFacetedMinMaxValues()?.[0] ?? '')}
            max={Number(props.column.getFacetedMinMaxValues()?.[1] ?? '')}
            value={
              (
                props.column.getFilterValue() as [number, number] | undefined
              )?.[1] ?? ''
            }
            onChange={(value) =>
              props.column.setFilterValue(
                (old: [number, number] | undefined) => [old?.[0], value],
              )
            }
            placeholder={`Max${
              props.column.getFacetedMinMaxValues()?.[1] !== undefined
                ? ` (${props.column.getFacetedMinMaxValues()?.[1]})`
                : ''
            }`}
            class="filter-input"
          />
        </div>
      ) : filterVariant() === 'select' ? (
        <select
          onChange={(e) => props.column.setFilterValue(e.currentTarget.value)}
          value={(props.column.getFilterValue() ?? '').toString()}
          class="filter-select"
        >
          <option value="">All</option>
          <For each={sortedUniqueValues()}>
            {(value) => <option value={String(value)}>{String(value)}</option>}
          </For>
        </select>
      ) : (
        <>
          <datalist id={props.column.id + 'list'}>
            <For each={sortedUniqueValues()}>
              {(value) => <option value={String(value)} />}
            </For>
          </datalist>
          <DebouncedInput
            type="text"
            value={(props.column.getFilterValue() ?? '') as string}
            onChange={(value) => props.column.setFilterValue(value)}
            placeholder={`Search (${props.column.getFacetedUniqueValues().size})`}
            class="filter-select"
            list={props.column.id + 'list'}
          />
        </>
      )}
    </>
  )
}

type AppTable = ReturnType<typeof createAppTable<Person>>

function TableHeader(props: {
  header: Header<typeof stockFeatures, Person, unknown>
  table: AppTable
}) {
  const column = () => props.header.column
  const style = () => ({
    ...getCommonPinningStyles(column()),
    'white-space': 'nowrap',
    width: `calc(var(--header-${props.header.id}-size) * 1px)`,
  })

  return (
    <th style={style()} colSpan={props.header.colSpan}>
      {!props.header.isPlaceholder ? (
        <>
          <div class="header-row">
            <div style={{ flex: 1, 'min-width': 0 }}>
              <div class="header-controls">
                {column().getCanPin() ? (
                  <span class="pin-actions">
                    {column().getIsPinned() !== 'left' ? (
                      <button
                        class="pin-button"
                        onClick={() => column().pin('left')}
                      >
                        {'<'}
                      </button>
                    ) : null}
                    {column().getIsPinned() ? (
                      <button
                        class="pin-button"
                        onClick={() => column().pin(false)}
                      >
                        x
                      </button>
                    ) : null}
                    {column().getIsPinned() !== 'right' ? (
                      <button
                        class="pin-button"
                        onClick={() => column().pin('right')}
                      >
                        {'>'}
                      </button>
                    ) : null}
                  </span>
                ) : null}
                {column().getCanGroup() ? (
                  <button
                    class="pin-button"
                    onClick={column().getToggleGroupingHandler()}
                  >
                    {column().getIsGrouped()
                      ? `Stop (${column().getGroupedIndex()})`
                      : 'Group'}
                  </button>
                ) : null}
              </div>
              {column().getCanSort() ? (
                <span
                  class="sortable-header"
                  onClick={column().getToggleSortingHandler()}
                >
                  <props.table.FlexRender header={props.header} />
                  {{
                    asc: ' â–²',
                    desc: ' â–¼',
                  }[column().getIsSorted() as string] ?? null}
                </span>
              ) : (
                <props.table.FlexRender header={props.header} />
              )}
              {column().getCanFilter() ? (
                <div>
                  <Filter column={column()} />
                </div>
              ) : null}
            </div>
          </div>
          {column().getCanResize() ? (
            <div
              onDblClick={() => column().resetSize()}
              onMouseDown={props.header.getResizeHandler()}
              onTouchStart={props.header.getResizeHandler()}
              class={`resizer ${column().getIsResizing() ? 'isResizing' : ''}`}
            />
          ) : null}
        </>
      ) : null}
    </th>
  )
}

function TableCell(props: {
  cell: Cell<typeof stockFeatures, Person, unknown>
  table: AppTable
}) {
  const className = () => {
    const groupingActive = props.table.atoms.grouping.get().length > 0
    const hasAggregation = !!props.cell.column.columnDef.aggregationFn
    return !groupingActive
      ? undefined
      : props.cell.getIsGrouped()
        ? 'cell-grouped'
        : hasAggregation && props.cell.getIsAggregated()
          ? 'cell-aggregated'
          : props.cell.getIsPlaceholder()
            ? 'cell-placeholder'
            : undefined
  }

  return (
    <td
      style={{
        ...getCommonPinningStyles(props.cell.column),
        width: `calc(var(--col-${props.cell.column.id}-size) * 1px)`,
      }}
      class={className()}
    >
      {props.cell.getIsGrouped() ? (
        <button
          onClick={props.cell.row.getToggleExpandedHandler()}
          style={{
            cursor: props.cell.row.getCanExpand() ? 'pointer' : 'normal',
          }}
        >
          {props.cell.row.getIsExpanded() ? 'v' : '>'}{' '}
          <props.table.FlexRender cell={props.cell} /> (
          {props.cell.row.subRows.length.toLocaleString()})
        </button>
      ) : (
        <props.table.FlexRender cell={props.cell} />
      )}
    </td>
  )
}

function PinnedRow(props: {
  row: Row<typeof stockFeatures, Person>
  table: AppTable
}) {
  const bottomRows = () => props.table.getBottomRows()
  return (
    <tr
      class="pinned-row"
      style={{
        position: 'sticky',
        top:
          props.row.getIsPinned() === 'top'
            ? `${props.row.getPinnedIndex() * 32 + 48}px`
            : undefined,
        bottom:
          props.row.getIsPinned() === 'bottom'
            ? `${(bottomRows().length - 1 - props.row.getPinnedIndex()) * 32}px`
            : undefined,
        'z-index': 1,
      }}
    >
      <For each={props.row.getVisibleCells()}>
        {(cell) => <TableCell cell={cell} table={props.table} />}
      </For>
    </tr>
  )
}

const columnHelper = createAppColumnHelper<Person>()

const columns = columnHelper.columns([
  columnHelper.display({
    id: 'select',
    size: 80,
    minSize: 80,
    maxSize: 80,
    enableSorting: false,
    enableGrouping: false,
    enableHiding: false,
    enableResizing: false,
    header: ({ table }) => (
      <IndeterminateCheckbox
        checked={table.getIsAllPageRowsSelected()}
        indeterminate={table.getIsSomePageRowsSelected()}
        onChange={table.getToggleAllPageRowsSelectedHandler()}
        title="Select all on this page"
      />
    ),
    cell: ({ row }) => (
      <div class="column-toggle-row">
        <IndeterminateCheckbox
          checked={row.getIsSelected()}
          disabled={!row.getCanSelect()}
          indeterminate={row.getIsSomeSelected()}
          onChange={row.getToggleSelectedHandler()}
        />{' '}
        <button
          class="pin-button"
          onClick={() => row.pin(row.getIsPinned() === 'top' ? false : 'top')}
        >
          {row.getIsPinned() === 'top' ? 'Pinned' : 'Pin'}
        </button>
      </div>
    ),
  }),
  columnHelper.accessor('firstName', {
    id: 'firstName',
    size: 200,
    header: 'First Name',
    filterFn: 'fuzzy',
    sortFn: fuzzySort,
    meta: { filterVariant: 'text' },
    getGroupingValue: (row) => `${row.firstName} ${row.lastName}`,
    cell: ({ row, getValue }) => (
      <div style={{ 'padding-left': `${row.depth * 1.5}rem` }}>
        {row.getCanExpand() ? (
          <button
            onClick={row.getToggleExpandedHandler()}
            style={{ cursor: 'pointer', 'margin-right': '0.25rem' }}
          >
            {row.getIsExpanded() ? 'v' : '>'}
          </button>
        ) : (
          <span style={{ 'margin-right': '0.25rem' }}>-</span>
        )}
        {String(getValue())}
      </div>
    ),
  }),
  columnHelper.accessor((row) => row.lastName, {
    id: 'lastName',
    size: 180,
    header: 'Last Name',
    meta: { filterVariant: 'text' },
  }),
  columnHelper.accessor('age', {
    id: 'age',
    size: 200,
    header: 'Age',
    meta: { filterVariant: 'range' },
    aggregationFn: 'median',
    aggregatedCell: ({ getValue }) =>
      Math.round(getValue<number>() * 100) / 100,
  }),
  columnHelper.accessor('visits', {
    id: 'visits',
    size: 200,
    header: 'Visits',
    meta: { filterVariant: 'range' },
    aggregationFn: 'sum',
    aggregatedCell: ({ getValue }) => getValue<number>().toLocaleString(),
  }),
  columnHelper.accessor('status', {
    id: 'status',
    size: 200,
    header: 'Status',
    sortFn: sortStatusFn,
    meta: { filterVariant: 'select' },
  }),
  columnHelper.accessor('progress', {
    id: 'progress',
    size: 200,
    header: 'Profile Progress',
    meta: { filterVariant: 'range' },
    aggregationFn: 'mean',
    cell: ({ getValue }) => `${Math.round(getValue<number>() * 100) / 100}%`,
    aggregatedCell: ({ getValue }) =>
      `${Math.round(getValue<number>() * 100) / 100}%`,
  }),
])

function App() {
  const [data, setData] = createSignal(makeData(1_000))
  const [, setRenderTick] = createSignal({})

  const table = createAppTable(
    {
      key: 'kitchen-sink', // needed for devtools
      columns,
      get data() {
        return data()
      },
      getSubRows: (row) => row.subRows,
      globalFilterFn: 'fuzzy',
      columnResizeMode: 'onChange',
      defaultColumn: { minSize: 200, maxSize: 800 },
      initialState: {
        columnOrder: columns.map((c) => c.id!),
        columnPinning: { left: ['select'], right: [] },
        pagination: { pageIndex: 0, pageSize: 20 },
      },
      keepPinnedRows: true,
      debugTable: true,
    },
    (state) => state,
  )

  useTanStackTableDevtools(table)

  const columnSizeVars = createMemo(() => {
    void table.atoms.columnResizing.get()
    void table.atoms.columnSizing.get()
    const colSizes: Record<string, number> = {}
    for (const header of table.getFlatHeaders()) {
      colSizes[`--header-${header.id}-size`] = header.getSize()
      colSizes[`--col-${header.column.id}-size`] = header.column.getSize()
    }
    return colSizes
  })

  const refreshData = () => setData(makeData(1_000))
  const nestedData = () => setData(makeData(100, 5, 3))
  const stress10k = () => setData(makeData(10_000))
  const stress100k = () => setData(makeData(100_000))
  const shuffleColumns = () => {
    table.setColumnOrder(
      faker.helpers.shuffle(table.getAllLeafColumns().map((d) => d.id)),
    )
  }

  return (
    <div class="demo-root">
      <h1>Kitchen Sink - All Features</h1>
      <div class="toolbar">
        <div class="toolbar-row">
          <DebouncedInput
            value={(table.atoms.globalFilter.get() ?? '') as string}
            onChange={(value) => table.setGlobalFilter(String(value))}
            class="global-filter-input"
            placeholder="Fuzzy search all columns..."
          />
        </div>
        <div class="toolbar-row">
          <button onClick={refreshData} class="demo-button demo-button-sm">
            Flat 1k
          </button>
          <button onClick={nestedData} class="demo-button demo-button-sm">
            Nested 100x5x3
          </button>
          <button onClick={stress10k} class="demo-button demo-button-sm">
            Stress 10k (flat)
          </button>
          <button onClick={stress100k} class="demo-button demo-button-sm">
            Stress 100k (flat)
          </button>
          <button
            onClick={() => table.reset()}
            class="demo-button demo-button-sm"
          >
            Reset Table
          </button>
          <button onClick={shuffleColumns} class="demo-button demo-button-sm">
            Shuffle Columns
          </button>
          <button
            onClick={() => setRenderTick({})}
            class="demo-button demo-button-sm"
          >
            Force Rerender
          </button>
          <span class="nowrap">
            {table.getSelectedRowModel().flatRows.length.toLocaleString()} of{' '}
            {table.getCoreRowModel().flatRows.length.toLocaleString()} selected
          </span>
        </div>
        <details class="column-toggle-panel">
          <summary class="column-toggle-panel-header">
            Column visibility
          </summary>
          <div class="column-toggle-row">
            <label>
              <input
                type="checkbox"
                checked={table.getIsAllColumnsVisible()}
                onChange={table.getToggleAllColumnsVisibilityHandler()}
              />{' '}
              Toggle All
            </label>
          </div>
          <For each={table.getAllLeafColumns()}>
            {(column) => (
              <div class="column-toggle-row">
                <label>
                  <input
                    type="checkbox"
                    checked={column.getIsVisible()}
                    disabled={!column.getCanHide()}
                    onChange={column.getToggleVisibilityHandler()}
                  />{' '}
                  {column.id}
                </label>
              </div>
            )}
          </For>
        </details>
      </div>
      <div class="table-container">
        <table
          style={{ ...columnSizeVars(), width: `${table.getTotalSize()}px` }}
        >
          <thead>
            <For each={table.getHeaderGroups()}>
              {(headerGroup) => (
                <tr>
                  <For each={headerGroup.headers}>
                    {(header) => <TableHeader header={header} table={table} />}
                  </For>
                </tr>
              )}
            </For>
          </thead>
          <tbody>
            <For each={table.getTopRows()}>
              {(row) => <PinnedRow row={row} table={table} />}
            </For>
            <For each={table.getCenterRows()}>
              {(row) => (
                <tr>
                  <For each={row.getVisibleCells()}>
                    {(cell) => <TableCell cell={cell} table={table} />}
                  </For>
                </tr>
              )}
            </For>
            <For each={table.getBottomRows()}>
              {(row) => <PinnedRow row={row} table={table} />}
            </For>
          </tbody>
        </table>
      </div>
      <div class="spacer-sm" />
      <div class="controls">
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.setPageIndex(0)}
          disabled={!table.getCanPreviousPage()}
        >
          {'<<'}
        </button>
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.previousPage()}
          disabled={!table.getCanPreviousPage()}
        >
          {'<'}
        </button>
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.nextPage()}
          disabled={!table.getCanNextPage()}
        >
          {'>'}
        </button>
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.setPageIndex(table.getPageCount() - 1)}
          disabled={!table.getCanNextPage()}
        >
          {'>>'}
        </button>
        <span class="inline-controls">
          <div>Page</div>
          <strong>
            {(table.atoms.pagination.get().pageIndex + 1).toLocaleString()} of{' '}
            {table.getPageCount().toLocaleString()}
          </strong>
        </span>
        <span class="inline-controls">
          | Go to page:
          <input
            type="number"
            min="1"
            max={table.getPageCount()}
            value={table.atoms.pagination.get().pageIndex + 1}
            onInput={(e) => {
              const page = e.currentTarget.value
                ? Number(e.currentTarget.value) - 1
                : 0
              table.setPageIndex(page)
            }}
            class="page-size-input"
          />
        </span>
        <select
          value={table.atoms.pagination.get().pageSize}
          onChange={(e) => table.setPageSize(Number(e.currentTarget.value))}
        >
          <For each={[10, 20, 30, 50, 100]}>
            {(pageSize) => <option value={pageSize}>Show {pageSize}</option>}
          </For>
        </select>
      </div>
      <div class="spacer-sm" />
      <div class="nowrap">
        {table.getRowModel().rows.length.toLocaleString()} rows on this page (
        {table.getFilteredRowModel().rows.length.toLocaleString()} filtered of{' '}
        {table.getCoreRowModel().rows.length.toLocaleString()} total)
      </div>
      <div class="spacer-md" />
      <details>
        <summary>Table state (live)</summary>
        <pre class="state-dump">
          {JSON.stringify(table.store.get(), null, 2)}
        </pre>
      </details>
    </div>
  )
}

export default App

Docs
CodeRabbit
Cloudflare
Railway
AG Grid
SerpAPI
OpenRouter
WorkOS
Netlify
Clerk
Sentry
Unkey
Electric
Prisma
CodeRabbit
Cloudflare
Railway
AG Grid
SerpAPI
OpenRouter
WorkOS
Netlify
Clerk
Sentry
Unkey
Electric
Prisma
Table API Reference
Column API Reference
Row API Reference
Cell API Reference
Header API Reference
Features API Reference
Static Functions API Reference

Svelte Example: Kitchen Sink

<script lang="ts">
  import { faker } from '@faker-js/faker'
  import {
    aggregationFns,
    createExpandedRowModel,
    createFacetedMinMaxValues,
    createFacetedRowModel,
    createFacetedUniqueValues,
    createFilteredRowModel,
    createGroupedRowModel,
    createPaginatedRowModel,
    createSortedRowModel,
    createTableHook,
    filterFns,
    FlexRender,
    sortFns,
    stockFeatures,
  } from '@tanstack/svelte-table'
  import { compareItems, rankItem } from '@tanstack/match-sorter-utils'
  import { makeData } from './makeData'
  import type { Person } from './makeData'
  import type {
    Cell,
    Column,
    FilterFn,
    Header,
    Row,
    SortFn,
  } from '@tanstack/svelte-table'
  import './index.css'

  const fuzzyFilter: FilterFn<typeof stockFeatures, Person> = (
    row,
    columnId,
    value,
    addMeta,
  ) => {
    const itemRank = rankItem(row.getValue(columnId), value)
    addMeta?.({ itemRank })
    return itemRank.passed
  }

  const fuzzySort: SortFn<typeof stockFeatures, Person> = (
    rowA,
    rowB,
    columnId,
  ) => {
    let dir = 0
    if (rowA.columnFiltersMeta[columnId]) {
      dir = compareItems(
        rowA.columnFiltersMeta[columnId].itemRank!,
        rowB.columnFiltersMeta[columnId].itemRank!,
      )
    }
    return dir === 0 ? sortFns.alphanumeric(rowA, rowB, columnId) : dir
  }

  const sortStatusFn: SortFn<typeof stockFeatures, Person> = (rowA, rowB) => {
    const statusOrder = ['single', 'complicated', 'relationship']
    return (
      statusOrder.indexOf(rowA.original.status) -
      statusOrder.indexOf(rowB.original.status)
    )
  }

  const { createAppTable, createAppColumnHelper } = createTableHook({
    features: stockFeatures,
    rowModels: {
      expandedRowModel: createExpandedRowModel(),
      filteredRowModel: createFilteredRowModel({
        ...filterFns,
        fuzzy: fuzzyFilter,
      }),
      facetedRowModel: createFacetedRowModel(),
      facetedMinMaxValues: createFacetedMinMaxValues(),
      facetedUniqueValues: createFacetedUniqueValues(),
      groupedRowModel: createGroupedRowModel(aggregationFns),
      paginatedRowModel: createPaginatedRowModel(),
      sortedRowModel: createSortedRowModel(sortFns),
    } as any,
  })

  const columnHelper = createAppColumnHelper<Person>()

  const columns = columnHelper.columns([
    columnHelper.display({
      id: 'select',
      size: 80,
      minSize: 80,
      maxSize: 80,
      enableSorting: false,
      enableGrouping: false,
      enableHiding: false,
      enableResizing: false,
      header: ({ table }) =>
        table.getIsAllPageRowsSelected()
          ? 'all'
          : table.getIsSomePageRowsSelected()
            ? 'some'
            : 'none',
      cell: ({ row }) => (row.getIsPinned() === 'top' ? 'Pinned' : 'Pin'),
    }),
    columnHelper.accessor('firstName', {
      id: 'firstName',
      size: 200,
      header: 'First Name',
      filterFn: 'fuzzy',
      sortFn: fuzzySort,
      meta: { filterVariant: 'text' },
      getGroupingValue: (row) => `${row.firstName} ${row.lastName}`,
    }),
    columnHelper.accessor((row) => row.lastName, {
      id: 'lastName',
      size: 180,
      header: 'Last Name',
      meta: { filterVariant: 'text' },
    }),
    columnHelper.accessor('age', {
      id: 'age',
      size: 200,
      header: 'Age',
      meta: { filterVariant: 'range' },
      aggregationFn: 'median',
      aggregatedCell: ({ getValue }) =>
        Math.round(getValue<number>() * 100) / 100,
    }),
    columnHelper.accessor('visits', {
      id: 'visits',
      size: 200,
      header: 'Visits',
      meta: { filterVariant: 'range' },
      aggregationFn: 'sum',
      aggregatedCell: ({ getValue }) => getValue<number>().toLocaleString(),
    }),
    columnHelper.accessor('status', {
      id: 'status',
      size: 200,
      header: 'Status',
      sortFn: sortStatusFn,
      meta: { filterVariant: 'select' },
    }),
    columnHelper.accessor('progress', {
      id: 'progress',
      size: 200,
      header: 'Profile Progress',
      meta: { filterVariant: 'range' },
      aggregationFn: 'mean',
      cell: ({ getValue }) => `${Math.round(getValue<number>() * 100) / 100}%`,
      aggregatedCell: ({ getValue }) =>
        `${Math.round(getValue<number>() * 100) / 100}%`,
    }),
  ])

  let data = $state(makeData(1_000))
  const debounceTimers = new Map<string, ReturnType<typeof setTimeout>>()

  const table = createAppTable(
    {
      columns,
      get data() {
        return data
      },
      getSubRows: (row) => row.subRows,
      globalFilterFn: 'fuzzy',
      columnResizeMode: 'onChange',
      defaultColumn: { minSize: 200, maxSize: 800 },
      initialState: {
        columnOrder: columns.map((c) => c.id!),
        columnPinning: { left: ['select'], right: [] },
        pagination: { pageIndex: 0, pageSize: 20 },
      },
      keepPinnedRows: true,
      debugTable: true,
    },
    (state) => state,
  )

  function debounceSet(key: string, setValue: () => void) {
    clearTimeout(debounceTimers.get(key))
    debounceTimers.set(
      key,
      setTimeout(() => {
        setValue()
        debounceTimers.delete(key)
      }, 300),
    )
  }

  function getCommonPinningStyle(column: Column<typeof stockFeatures, Person>) {
    const isPinned = column.getIsPinned()
    const isLastLeftPinnedColumn =
      isPinned === 'left' && column.getIsLastColumn('left')
    const isFirstRightPinnedColumn =
      isPinned === 'right' && column.getIsFirstColumn('right')

    return [
      isLastLeftPinnedColumn
        ? 'box-shadow: -4px 0 4px -4px gray inset'
        : isFirstRightPinnedColumn
          ? 'box-shadow: 4px 0 4px -4px gray inset'
          : '',
      isPinned === 'left' ? `left: ${column.getStart('left')}px` : '',
      isPinned === 'right' ? `right: ${column.getAfter('right')}px` : '',
      `opacity: ${isPinned ? 0.97 : 1}`,
      `position: ${isPinned ? 'sticky' : 'relative'}`,
      `z-index: ${isPinned ? 1 : 0}`,
    ]
      .filter(Boolean)
      .join('; ')
  }

  function headerStyle(header: Header<typeof stockFeatures, Person, unknown>) {
    return `${getCommonPinningStyle(header.column)}; white-space: nowrap; width: calc(var(--header-${header.id}-size) * 1px)`
  }

  function cellStyle(cell: Cell<typeof stockFeatures, Person, unknown>) {
    return `${getCommonPinningStyle(cell.column)}; width: calc(var(--col-${cell.column.id}-size) * 1px)`
  }

  function cellClass(cell: Cell<typeof stockFeatures, Person, unknown>) {
    const groupingActive = table.state.grouping.length > 0
    const hasAggregation = !!cell.column.columnDef.aggregationFn
    return !groupingActive
      ? undefined
      : cell.getIsGrouped()
        ? 'cell-grouped'
        : hasAggregation && cell.getIsAggregated()
          ? 'cell-aggregated'
          : cell.getIsPlaceholder()
            ? 'cell-placeholder'
            : undefined
  }

  function pinnedRowStyle(row: Row<typeof stockFeatures, Person>) {
    const bottomRows = table.getBottomRows()
    return [
      'position: sticky',
      row.getIsPinned() === 'top'
        ? `top: ${row.getPinnedIndex() * 32 + 48}px`
        : '',
      row.getIsPinned() === 'bottom'
        ? `bottom: ${(bottomRows.length - 1 - row.getPinnedIndex()) * 32}px`
        : '',
      'z-index: 1',
    ]
      .filter(Boolean)
      .join('; ')
  }

  function tableStyle() {
    const styles = [`width: ${table.getTotalSize()}px`]
    for (const header of table.getFlatHeaders()) {
      styles.push(`--header-${header.id}-size: ${header.getSize()}`)
      styles.push(`--col-${header.column.id}-size: ${header.column.getSize()}`)
    }
    return styles.join('; ')
  }

  function sortedUniqueValues(column: Column<typeof stockFeatures, Person>) {
    if (column.columnDef.meta?.filterVariant === 'range') return []
    return Array.from(column.getFacetedUniqueValues().keys())
      .sort()
      .slice(0, 5000)
  }

  function updateRangeFilter(
    column: Column<typeof stockFeatures, Person>,
    index: 0 | 1,
    value: string,
  ) {
    column.setFilterValue((old: [number, number] | undefined) =>
      index === 0 ? [value, old?.[1]] : [old?.[0], value],
    )
  }

  const refreshData = () => { data = makeData(1_000) }
  const nestedData = () => { data = makeData(100, 5, 3) }
  const stress10k = () => { data = makeData(10_000) }
  const stress100k = () => { data = makeData(100_000) }
  const shuffleColumns = () => {
    table.setColumnOrder(
      faker.helpers.shuffle(table.getAllLeafColumns().map((d) => d.id)),
    )
  }
</script>

<div class="demo-root">
  <h1>Kitchen Sink - All Features</h1>
  <div class="toolbar">
    <div class="toolbar-row">
      <input
        class="global-filter-input"
        placeholder="Fuzzy search all columns..."
        value={(table.state.globalFilter ?? '') as string}
        oninput={(event) =>
          debounceSet('global', () =>
            table.setGlobalFilter((event.target as HTMLInputElement).value),
          )}
      />
    </div>
    <div class="toolbar-row">
      <button onclick={refreshData} class="demo-button demo-button-sm">Flat 1k</button>
      <button onclick={nestedData} class="demo-button demo-button-sm">Nested 100x5x3</button>
      <button onclick={stress10k} class="demo-button demo-button-sm">Stress 10k (flat)</button>
      <button onclick={stress100k} class="demo-button demo-button-sm">Stress 100k (flat)</button>
      <button onclick={() => table.reset()} class="demo-button demo-button-sm">Reset Table</button>
      <button onclick={shuffleColumns} class="demo-button demo-button-sm">Shuffle Columns</button>
      <span class="nowrap">
        {table.getSelectedRowModel().flatRows.length.toLocaleString()} of{' '}
        {table.getCoreRowModel().flatRows.length.toLocaleString()} selected
      </span>
    </div>
    <details class="column-toggle-panel">
      <summary class="column-toggle-panel-header">Column visibility</summary>
      <div class="column-toggle-row">
        <label>
          <input
            type="checkbox"
            checked={table.getIsAllColumnsVisible()}
            onchange={table.getToggleAllColumnsVisibilityHandler()}
          />{' '}
          Toggle All
        </label>
      </div>
      {#each table.getAllLeafColumns() as column (column.id)}
        <div class="column-toggle-row">
          <label>
            <input
              type="checkbox"
              checked={column.getIsVisible()}
              disabled={!column.getCanHide()}
              onchange={column.getToggleVisibilityHandler()}
            />{' '}
            {column.id}
          </label>
        </div>
      {/each}
    </details>
  </div>

  <div class="table-container">
    <table style={tableStyle()}>
      <thead>
        {#each table.getHeaderGroups() as headerGroup (headerGroup.id)}
          <tr>
            {#each headerGroup.headers as header (header.id)}
              <th colSpan={header.colSpan} style={headerStyle(header)}>
                {#if !header.isPlaceholder}
                  <div class="header-row">
                    <div style="flex: 1; min-width: 0">
                      <div class="header-controls">
                        {#if header.column.getCanPin()}
                          <span class="pin-actions">
                            {#if header.column.getIsPinned() !== 'left'}
                              <button class="pin-button" onclick={() => header.column.pin('left')}>{'<'}</button>
                            {/if}
                            {#if header.column.getIsPinned()}
                              <button class="pin-button" onclick={() => header.column.pin(false)}>x</button>
                            {/if}
                            {#if header.column.getIsPinned() !== 'right'}
                              <button class="pin-button" onclick={() => header.column.pin('right')}>{'>'}</button>
                            {/if}
                          </span>
                        {/if}
                        {#if header.column.getCanGroup()}
                          <button class="pin-button" onclick={header.column.getToggleGroupingHandler()}>
                            {header.column.getIsGrouped()
                              ? `Stop (${header.column.getGroupedIndex()})`
                              : 'Group'}
                          </button>
                        {/if}
                      </div>
                      {#if header.column.id === 'select'}
                        <input
                          type="checkbox"
                          checked={table.getIsAllPageRowsSelected()}
                          indeterminate={table.getIsSomePageRowsSelected()}
                          onchange={table.getToggleAllPageRowsSelectedHandler()}
                        />
                      {:else if header.column.getCanSort()}
                        <button
                          type="button"
                          class="sortable-header header-sort-button"
                          onclick={header.column.getToggleSortingHandler()}
                        >
                          <FlexRender header={header} />
                          {header.column.getIsSorted() === 'asc'
                            ? ' â–²'
                            : header.column.getIsSorted() === 'desc'
                              ? ' â–¼'
                              : ''}
                        </button>
                      {:else}
                        <FlexRender header={header} />
                      {/if}
                      {#if header.column.getCanFilter()}
                        <div>
                          {#if header.column.columnDef.meta?.filterVariant === 'range'}
                            <div class="filter-row">
                              <input
                                type="number"
                                class="filter-input"
                                min={header.column.getFacetedMinMaxValues()?.[0] ?? ''}
                                max={header.column.getFacetedMinMaxValues()?.[1] ?? ''}
                                value={(header.column.getFilterValue() as [number, number] | undefined)?.[0] ?? ''}
                                placeholder={`Min${header.column.getFacetedMinMaxValues()?.[0] !== undefined ? ` (${header.column.getFacetedMinMaxValues()?.[0]})` : ''}`}
                                oninput={(event) =>
                                  debounceSet(header.column.id + '-min', () =>
                                    updateRangeFilter(
                                      header.column,
                                      0,
                                      (event.target as HTMLInputElement).value,
                                    ),
                                  )}
                              />
                              <input
                                type="number"
                                class="filter-input"
                                min={header.column.getFacetedMinMaxValues()?.[0] ?? ''}
                                max={header.column.getFacetedMinMaxValues()?.[1] ?? ''}
                                value={(header.column.getFilterValue() as [number, number] | undefined)?.[1] ?? ''}
                                placeholder={`Max${header.column.getFacetedMinMaxValues()?.[1] !== undefined ? ` (${header.column.getFacetedMinMaxValues()?.[1]})` : ''}`}
                                oninput={(event) =>
                                  debounceSet(header.column.id + '-max', () =>
                                    updateRangeFilter(
                                      header.column,
                                      1,
                                      (event.target as HTMLInputElement).value,
                                    ),
                                  )}
                              />
                            </div>
                          {:else if header.column.columnDef.meta?.filterVariant === 'select'}
                            <select
                              class="filter-select"
                              value={(header.column.getFilterValue() ?? '').toString()}
                              onchange={(event) =>
                                header.column.setFilterValue(
                                  (event.target as HTMLSelectElement).value,
                                )}
                            >
                              <option value="">All</option>
                              {#each sortedUniqueValues(header.column) as value (String(value))}
                                <option value={String(value)}>{String(value)}</option>
                              {/each}
                            </select>
                          {:else}
                            <datalist id={header.column.id + 'list'}>
                              {#each sortedUniqueValues(header.column) as value (String(value))}
                                <option value={String(value)}></option>
                              {/each}
                            </datalist>
                            <input
                              type="text"
                              class="filter-select"
                              list={header.column.id + 'list'}
                              value={(header.column.getFilterValue() ?? '') as string}
                              placeholder={`Search (${header.column.getFacetedUniqueValues().size})`}
                              oninput={(event) =>
                                debounceSet(header.column.id, () =>
                                  header.column.setFilterValue(
                                    (event.target as HTMLInputElement).value,
                                  ),
                                )}
                            />
                          {/if}
                        </div>
                      {/if}
                    </div>
                  </div>
                  {#if header.column.getCanResize()}
                    <button
                      type="button"
                      aria-label={`Resize ${header.column.id} column`}
                      ondblclick={() => header.column.resetSize()}
                      onmousedown={header.getResizeHandler()}
                      ontouchstart={header.getResizeHandler()}
                      class={`resizer ${header.column.getIsResizing() ? 'isResizing' : ''}`}
                    ></button>
                  {/if}
                {/if}
              </th>
            {/each}
          </tr>
        {/each}
      </thead>
      <tbody>
        {#each table.getTopRows() as row (row.id)}
          <tr class="pinned-row" style={pinnedRowStyle(row)}>
            {#each row.getVisibleCells() as cell (cell.id)}
              <td style={cellStyle(cell)} class={cellClass(cell)}>
                <FlexRender cell={cell} />
              </td>
            {/each}
          </tr>
        {/each}
        {#each table.getCenterRows() as row (row.id)}
          <tr>
            {#each row.getVisibleCells() as cell (cell.id)}
              <td style={cellStyle(cell)} class={cellClass(cell)}>
                {#if cell.column.id === 'select'}
                  <div class="column-toggle-row">
                    <input
                      type="checkbox"
                      checked={cell.row.getIsSelected()}
                      disabled={!cell.row.getCanSelect()}
                      indeterminate={cell.row.getIsSomeSelected()}
                      onchange={cell.row.getToggleSelectedHandler()}
                    />{' '}
                    <button
                      class="pin-button"
                      onclick={() =>
                        cell.row.pin(
                          cell.row.getIsPinned() === 'top' ? false : 'top',
                        )}
                    >
                      {cell.row.getIsPinned() === 'top' ? 'Pinned' : 'Pin'}
                    </button>
                  </div>
                {:else if cell.column.id === 'firstName'}
                  <div style={`padding-left: ${cell.row.depth * 1.5}rem`}>
                    {#if cell.row.getCanExpand()}
                      <button
                        onclick={cell.row.getToggleExpandedHandler()}
                        style="cursor: pointer; margin-right: 0.25rem"
                      >
                        {cell.row.getIsExpanded() ? 'v' : '>'}
                      </button>
                    {:else}
                      <span style="margin-right: 0.25rem">-</span>
                    {/if}
                    <FlexRender cell={cell} />
                  </div>
                {:else if cell.getIsGrouped()}
                  <button
                    onclick={cell.row.getToggleExpandedHandler()}
                    style:cursor={cell.row.getCanExpand() ? 'pointer' : 'normal'}
                  >
                    {cell.row.getIsExpanded() ? 'v' : '>'}
                    <FlexRender cell={cell} />
                    ({cell.row.subRows.length.toLocaleString()})
                  </button>
                {:else}
                  <FlexRender cell={cell} />
                {/if}
              </td>
            {/each}
          </tr>
        {/each}
        {#each table.getBottomRows() as row (row.id)}
          <tr class="pinned-row" style={pinnedRowStyle(row)}>
            {#each row.getVisibleCells() as cell (cell.id)}
              <td style={cellStyle(cell)} class={cellClass(cell)}>
                <FlexRender cell={cell} />
              </td>
            {/each}
          </tr>
        {/each}
      </tbody>
    </table>
  </div>

  <div class="spacer-sm"></div>
  <div class="controls">
    <button class="demo-button demo-button-sm" onclick={() => table.setPageIndex(0)} disabled={!table.getCanPreviousPage()}>{'<<'}</button>
    <button class="demo-button demo-button-sm" onclick={() => table.previousPage()} disabled={!table.getCanPreviousPage()}>{'<'}</button>
    <button class="demo-button demo-button-sm" onclick={() => table.nextPage()} disabled={!table.getCanNextPage()}>{'>'}</button>
    <button class="demo-button demo-button-sm" onclick={() => table.setPageIndex(table.getPageCount() - 1)} disabled={!table.getCanNextPage()}>{'>>'}</button>
    <span class="inline-controls">
      <div>Page</div>
      <strong>
        {(table.state.pagination.pageIndex + 1).toLocaleString()} of{' '}
        {table.getPageCount().toLocaleString()}
      </strong>
    </span>
    <span class="inline-controls">
      | Go to page:
      <input
        type="number"
        min="1"
        max={table.getPageCount()}
        value={table.state.pagination.pageIndex + 1}
        oninput={(event) => {
          const page = (event.target as HTMLInputElement).value
            ? Number((event.target as HTMLInputElement).value) - 1
            : 0
          table.setPageIndex(page)
        }}
        class="page-size-input"
      />
    </span>
    <select
      value={table.state.pagination.pageSize}
      onchange={(event) =>
        table.setPageSize(Number((event.target as HTMLSelectElement).value))}
    >
      {#each [10, 20, 30, 50, 100] as pageSize}
        <option value={pageSize}>Show {pageSize}</option>
      {/each}
    </select>
  </div>
  <div class="spacer-sm"></div>
  <div class="nowrap">
    {table.getRowModel().rows.length.toLocaleString()} rows on this page (
    {table.getFilteredRowModel().rows.length.toLocaleString()} filtered of{' '}
    {table.getCoreRowModel().rows.length.toLocaleString()} total)
  </div>
  <div class="spacer-md"></div>
  <details>
    <summary>Table state (live)</summary>
    <pre class="state-dump">{JSON.stringify(table.state, null, 2)}</pre>
  </details>
</div>
<script lang="ts">
  import { faker } from '@faker-js/faker'
  import {
    aggregationFns,
    createExpandedRowModel,
    createFacetedMinMaxValues,
    createFacetedRowModel,
    createFacetedUniqueValues,
    createFilteredRowModel,
    createGroupedRowModel,
    createPaginatedRowModel,
    createSortedRowModel,
    createTableHook,
    filterFns,
    FlexRender,
    sortFns,
    stockFeatures,
  } from '@tanstack/svelte-table'
  import { compareItems, rankItem } from '@tanstack/match-sorter-utils'
  import { makeData } from './makeData'
  import type { Person } from './makeData'
  import type {
    Cell,
    Column,
    FilterFn,
    Header,
    Row,
    SortFn,
  } from '@tanstack/svelte-table'
  import './index.css'

  const fuzzyFilter: FilterFn<typeof stockFeatures, Person> = (
    row,
    columnId,
    value,
    addMeta,
  ) => {
    const itemRank = rankItem(row.getValue(columnId), value)
    addMeta?.({ itemRank })
    return itemRank.passed
  }

  const fuzzySort: SortFn<typeof stockFeatures, Person> = (
    rowA,
    rowB,
    columnId,
  ) => {
    let dir = 0
    if (rowA.columnFiltersMeta[columnId]) {
      dir = compareItems(
        rowA.columnFiltersMeta[columnId].itemRank!,
        rowB.columnFiltersMeta[columnId].itemRank!,
      )
    }
    return dir === 0 ? sortFns.alphanumeric(rowA, rowB, columnId) : dir
  }

  const sortStatusFn: SortFn<typeof stockFeatures, Person> = (rowA, rowB) => {
    const statusOrder = ['single', 'complicated', 'relationship']
    return (
      statusOrder.indexOf(rowA.original.status) -
      statusOrder.indexOf(rowB.original.status)
    )
  }

  const { createAppTable, createAppColumnHelper } = createTableHook({
    features: stockFeatures,
    rowModels: {
      expandedRowModel: createExpandedRowModel(),
      filteredRowModel: createFilteredRowModel({
        ...filterFns,
        fuzzy: fuzzyFilter,
      }),
      facetedRowModel: createFacetedRowModel(),
      facetedMinMaxValues: createFacetedMinMaxValues(),
      facetedUniqueValues: createFacetedUniqueValues(),
      groupedRowModel: createGroupedRowModel(aggregationFns),
      paginatedRowModel: createPaginatedRowModel(),
      sortedRowModel: createSortedRowModel(sortFns),
    } as any,
  })

  const columnHelper = createAppColumnHelper<Person>()

  const columns = columnHelper.columns([
    columnHelper.display({
      id: 'select',
      size: 80,
      minSize: 80,
      maxSize: 80,
      enableSorting: false,
      enableGrouping: false,
      enableHiding: false,
      enableResizing: false,
      header: ({ table }) =>
        table.getIsAllPageRowsSelected()
          ? 'all'
          : table.getIsSomePageRowsSelected()
            ? 'some'
            : 'none',
      cell: ({ row }) => (row.getIsPinned() === 'top' ? 'Pinned' : 'Pin'),
    }),
    columnHelper.accessor('firstName', {
      id: 'firstName',
      size: 200,
      header: 'First Name',
      filterFn: 'fuzzy',
      sortFn: fuzzySort,
      meta: { filterVariant: 'text' },
      getGroupingValue: (row) => `${row.firstName} ${row.lastName}`,
    }),
    columnHelper.accessor((row) => row.lastName, {
      id: 'lastName',
      size: 180,
      header: 'Last Name',
      meta: { filterVariant: 'text' },
    }),
    columnHelper.accessor('age', {
      id: 'age',
      size: 200,
      header: 'Age',
      meta: { filterVariant: 'range' },
      aggregationFn: 'median',
      aggregatedCell: ({ getValue }) =>
        Math.round(getValue<number>() * 100) / 100,
    }),
    columnHelper.accessor('visits', {
      id: 'visits',
      size: 200,
      header: 'Visits',
      meta: { filterVariant: 'range' },
      aggregationFn: 'sum',
      aggregatedCell: ({ getValue }) => getValue<number>().toLocaleString(),
    }),
    columnHelper.accessor('status', {
      id: 'status',
      size: 200,
      header: 'Status',
      sortFn: sortStatusFn,
      meta: { filterVariant: 'select' },
    }),
    columnHelper.accessor('progress', {
      id: 'progress',
      size: 200,
      header: 'Profile Progress',
      meta: { filterVariant: 'range' },
      aggregationFn: 'mean',
      cell: ({ getValue }) => `${Math.round(getValue<number>() * 100) / 100}%`,
      aggregatedCell: ({ getValue }) =>
        `${Math.round(getValue<number>() * 100) / 100}%`,
    }),
  ])

  let data = $state(makeData(1_000))
  const debounceTimers = new Map<string, ReturnType<typeof setTimeout>>()

  const table = createAppTable(
    {
      columns,
      get data() {
        return data
      },
      getSubRows: (row) => row.subRows,
      globalFilterFn: 'fuzzy',
      columnResizeMode: 'onChange',
      defaultColumn: { minSize: 200, maxSize: 800 },
      initialState: {
        columnOrder: columns.map((c) => c.id!),
        columnPinning: { left: ['select'], right: [] },
        pagination: { pageIndex: 0, pageSize: 20 },
      },
      keepPinnedRows: true,
      debugTable: true,
    },
    (state) => state,
  )

  function debounceSet(key: string, setValue: () => void) {
    clearTimeout(debounceTimers.get(key))
    debounceTimers.set(
      key,
      setTimeout(() => {
        setValue()
        debounceTimers.delete(key)
      }, 300),
    )
  }

  function getCommonPinningStyle(column: Column<typeof stockFeatures, Person>) {
    const isPinned = column.getIsPinned()
    const isLastLeftPinnedColumn =
      isPinned === 'left' && column.getIsLastColumn('left')
    const isFirstRightPinnedColumn =
      isPinned === 'right' && column.getIsFirstColumn('right')

    return [
      isLastLeftPinnedColumn
        ? 'box-shadow: -4px 0 4px -4px gray inset'
        : isFirstRightPinnedColumn
          ? 'box-shadow: 4px 0 4px -4px gray inset'
          : '',
      isPinned === 'left' ? `left: ${column.getStart('left')}px` : '',
      isPinned === 'right' ? `right: ${column.getAfter('right')}px` : '',
      `opacity: ${isPinned ? 0.97 : 1}`,
      `position: ${isPinned ? 'sticky' : 'relative'}`,
      `z-index: ${isPinned ? 1 : 0}`,
    ]
      .filter(Boolean)
      .join('; ')
  }

  function headerStyle(header: Header<typeof stockFeatures, Person, unknown>) {
    return `${getCommonPinningStyle(header.column)}; white-space: nowrap; width: calc(var(--header-${header.id}-size) * 1px)`
  }

  function cellStyle(cell: Cell<typeof stockFeatures, Person, unknown>) {
    return `${getCommonPinningStyle(cell.column)}; width: calc(var(--col-${cell.column.id}-size) * 1px)`
  }

  function cellClass(cell: Cell<typeof stockFeatures, Person, unknown>) {
    const groupingActive = table.state.grouping.length > 0
    const hasAggregation = !!cell.column.columnDef.aggregationFn
    return !groupingActive
      ? undefined
      : cell.getIsGrouped()
        ? 'cell-grouped'
        : hasAggregation && cell.getIsAggregated()
          ? 'cell-aggregated'
          : cell.getIsPlaceholder()
            ? 'cell-placeholder'
            : undefined
  }

  function pinnedRowStyle(row: Row<typeof stockFeatures, Person>) {
    const bottomRows = table.getBottomRows()
    return [
      'position: sticky',
      row.getIsPinned() === 'top'
        ? `top: ${row.getPinnedIndex() * 32 + 48}px`
        : '',
      row.getIsPinned() === 'bottom'
        ? `bottom: ${(bottomRows.length - 1 - row.getPinnedIndex()) * 32}px`
        : '',
      'z-index: 1',
    ]
      .filter(Boolean)
      .join('; ')
  }

  function tableStyle() {
    const styles = [`width: ${table.getTotalSize()}px`]
    for (const header of table.getFlatHeaders()) {
      styles.push(`--header-${header.id}-size: ${header.getSize()}`)
      styles.push(`--col-${header.column.id}-size: ${header.column.getSize()}`)
    }
    return styles.join('; ')
  }

  function sortedUniqueValues(column: Column<typeof stockFeatures, Person>) {
    if (column.columnDef.meta?.filterVariant === 'range') return []
    return Array.from(column.getFacetedUniqueValues().keys())
      .sort()
      .slice(0, 5000)
  }

  function updateRangeFilter(
    column: Column<typeof stockFeatures, Person>,
    index: 0 | 1,
    value: string,
  ) {
    column.setFilterValue((old: [number, number] | undefined) =>
      index === 0 ? [value, old?.[1]] : [old?.[0], value],
    )
  }

  const refreshData = () => { data = makeData(1_000) }
  const nestedData = () => { data = makeData(100, 5, 3) }
  const stress10k = () => { data = makeData(10_000) }
  const stress100k = () => { data = makeData(100_000) }
  const shuffleColumns = () => {
    table.setColumnOrder(
      faker.helpers.shuffle(table.getAllLeafColumns().map((d) => d.id)),
    )
  }
</script>

<div class="demo-root">
  <h1>Kitchen Sink - All Features</h1>
  <div class="toolbar">
    <div class="toolbar-row">
      <input
        class="global-filter-input"
        placeholder="Fuzzy search all columns..."
        value={(table.state.globalFilter ?? '') as string}
        oninput={(event) =>
          debounceSet('global', () =>
            table.setGlobalFilter((event.target as HTMLInputElement).value),
          )}
      />
    </div>
    <div class="toolbar-row">
      <button onclick={refreshData} class="demo-button demo-button-sm">Flat 1k</button>
      <button onclick={nestedData} class="demo-button demo-button-sm">Nested 100x5x3</button>
      <button onclick={stress10k} class="demo-button demo-button-sm">Stress 10k (flat)</button>
      <button onclick={stress100k} class="demo-button demo-button-sm">Stress 100k (flat)</button>
      <button onclick={() => table.reset()} class="demo-button demo-button-sm">Reset Table</button>
      <button onclick={shuffleColumns} class="demo-button demo-button-sm">Shuffle Columns</button>
      <span class="nowrap">
        {table.getSelectedRowModel().flatRows.length.toLocaleString()} of{' '}
        {table.getCoreRowModel().flatRows.length.toLocaleString()} selected
      </span>
    </div>
    <details class="column-toggle-panel">
      <summary class="column-toggle-panel-header">Column visibility</summary>
      <div class="column-toggle-row">
        <label>
          <input
            type="checkbox"
            checked={table.getIsAllColumnsVisible()}
            onchange={table.getToggleAllColumnsVisibilityHandler()}
          />{' '}
          Toggle All
        </label>
      </div>
      {#each table.getAllLeafColumns() as column (column.id)}
        <div class="column-toggle-row">
          <label>
            <input
              type="checkbox"
              checked={column.getIsVisible()}
              disabled={!column.getCanHide()}
              onchange={column.getToggleVisibilityHandler()}
            />{' '}
            {column.id}
          </label>
        </div>
      {/each}
    </details>
  </div>

  <div class="table-container">
    <table style={tableStyle()}>
      <thead>
        {#each table.getHeaderGroups() as headerGroup (headerGroup.id)}
          <tr>
            {#each headerGroup.headers as header (header.id)}
              <th colSpan={header.colSpan} style={headerStyle(header)}>
                {#if !header.isPlaceholder}
                  <div class="header-row">
                    <div style="flex: 1; min-width: 0">
                      <div class="header-controls">
                        {#if header.column.getCanPin()}
                          <span class="pin-actions">
                            {#if header.column.getIsPinned() !== 'left'}
                              <button class="pin-button" onclick={() => header.column.pin('left')}>{'<'}</button>
                            {/if}
                            {#if header.column.getIsPinned()}
                              <button class="pin-button" onclick={() => header.column.pin(false)}>x</button>
                            {/if}
                            {#if header.column.getIsPinned() !== 'right'}
                              <button class="pin-button" onclick={() => header.column.pin('right')}>{'>'}</button>
                            {/if}
                          </span>
                        {/if}
                        {#if header.column.getCanGroup()}
                          <button class="pin-button" onclick={header.column.getToggleGroupingHandler()}>
                            {header.column.getIsGrouped()
                              ? `Stop (${header.column.getGroupedIndex()})`
                              : 'Group'}
                          </button>
                        {/if}
                      </div>
                      {#if header.column.id === 'select'}
                        <input
                          type="checkbox"
                          checked={table.getIsAllPageRowsSelected()}
                          indeterminate={table.getIsSomePageRowsSelected()}
                          onchange={table.getToggleAllPageRowsSelectedHandler()}
                        />
                      {:else if header.column.getCanSort()}
                        <button
                          type="button"
                          class="sortable-header header-sort-button"
                          onclick={header.column.getToggleSortingHandler()}
                        >
                          <FlexRender header={header} />
                          {header.column.getIsSorted() === 'asc'
                            ? ' â–²'
                            : header.column.getIsSorted() === 'desc'
                              ? ' â–¼'
                              : ''}
                        </button>
                      {:else}
                        <FlexRender header={header} />
                      {/if}
                      {#if header.column.getCanFilter()}
                        <div>
                          {#if header.column.columnDef.meta?.filterVariant === 'range'}
                            <div class="filter-row">
                              <input
                                type="number"
                                class="filter-input"
                                min={header.column.getFacetedMinMaxValues()?.[0] ?? ''}
                                max={header.column.getFacetedMinMaxValues()?.[1] ?? ''}
                                value={(header.column.getFilterValue() as [number, number] | undefined)?.[0] ?? ''}
                                placeholder={`Min${header.column.getFacetedMinMaxValues()?.[0] !== undefined ? ` (${header.column.getFacetedMinMaxValues()?.[0]})` : ''}`}
                                oninput={(event) =>
                                  debounceSet(header.column.id + '-min', () =>
                                    updateRangeFilter(
                                      header.column,
                                      0,
                                      (event.target as HTMLInputElement).value,
                                    ),
                                  )}
                              />
                              <input
                                type="number"
                                class="filter-input"
                                min={header.column.getFacetedMinMaxValues()?.[0] ?? ''}
                                max={header.column.getFacetedMinMaxValues()?.[1] ?? ''}
                                value={(header.column.getFilterValue() as [number, number] | undefined)?.[1] ?? ''}
                                placeholder={`Max${header.column.getFacetedMinMaxValues()?.[1] !== undefined ? ` (${header.column.getFacetedMinMaxValues()?.[1]})` : ''}`}
                                oninput={(event) =>
                                  debounceSet(header.column.id + '-max', () =>
                                    updateRangeFilter(
                                      header.column,
                                      1,
                                      (event.target as HTMLInputElement).value,
                                    ),
                                  )}
                              />
                            </div>
                          {:else if header.column.columnDef.meta?.filterVariant === 'select'}
                            <select
                              class="filter-select"
                              value={(header.column.getFilterValue() ?? '').toString()}
                              onchange={(event) =>
                                header.column.setFilterValue(
                                  (event.target as HTMLSelectElement).value,
                                )}
                            >
                              <option value="">All</option>
                              {#each sortedUniqueValues(header.column) as value (String(value))}
                                <option value={String(value)}>{String(value)}</option>
                              {/each}
                            </select>
                          {:else}
                            <datalist id={header.column.id + 'list'}>
                              {#each sortedUniqueValues(header.column) as value (String(value))}
                                <option value={String(value)}></option>
                              {/each}
                            </datalist>
                            <input
                              type="text"
                              class="filter-select"
                              list={header.column.id + 'list'}
                              value={(header.column.getFilterValue() ?? '') as string}
                              placeholder={`Search (${header.column.getFacetedUniqueValues().size})`}
                              oninput={(event) =>
                                debounceSet(header.column.id, () =>
                                  header.column.setFilterValue(
                                    (event.target as HTMLInputElement).value,
                                  ),
                                )}
                            />
                          {/if}
                        </div>
                      {/if}
                    </div>
                  </div>
                  {#if header.column.getCanResize()}
                    <button
                      type="button"
                      aria-label={`Resize ${header.column.id} column`}
                      ondblclick={() => header.column.resetSize()}
                      onmousedown={header.getResizeHandler()}
                      ontouchstart={header.getResizeHandler()}
                      class={`resizer ${header.column.getIsResizing() ? 'isResizing' : ''}`}
                    ></button>
                  {/if}
                {/if}
              </th>
            {/each}
          </tr>
        {/each}
      </thead>
      <tbody>
        {#each table.getTopRows() as row (row.id)}
          <tr class="pinned-row" style={pinnedRowStyle(row)}>
            {#each row.getVisibleCells() as cell (cell.id)}
              <td style={cellStyle(cell)} class={cellClass(cell)}>
                <FlexRender cell={cell} />
              </td>
            {/each}
          </tr>
        {/each}
        {#each table.getCenterRows() as row (row.id)}
          <tr>
            {#each row.getVisibleCells() as cell (cell.id)}
              <td style={cellStyle(cell)} class={cellClass(cell)}>
                {#if cell.column.id === 'select'}
                  <div class="column-toggle-row">
                    <input
                      type="checkbox"
                      checked={cell.row.getIsSelected()}
                      disabled={!cell.row.getCanSelect()}
                      indeterminate={cell.row.getIsSomeSelected()}
                      onchange={cell.row.getToggleSelectedHandler()}
                    />{' '}
                    <button
                      class="pin-button"
                      onclick={() =>
                        cell.row.pin(
                          cell.row.getIsPinned() === 'top' ? false : 'top',
                        )}
                    >
                      {cell.row.getIsPinned() === 'top' ? 'Pinned' : 'Pin'}
                    </button>
                  </div>
                {:else if cell.column.id === 'firstName'}
                  <div style={`padding-left: ${cell.row.depth * 1.5}rem`}>
                    {#if cell.row.getCanExpand()}
                      <button
                        onclick={cell.row.getToggleExpandedHandler()}
                        style="cursor: pointer; margin-right: 0.25rem"
                      >
                        {cell.row.getIsExpanded() ? 'v' : '>'}
                      </button>
                    {:else}
                      <span style="margin-right: 0.25rem">-</span>
                    {/if}
                    <FlexRender cell={cell} />
                  </div>
                {:else if cell.getIsGrouped()}
                  <button
                    onclick={cell.row.getToggleExpandedHandler()}
                    style:cursor={cell.row.getCanExpand() ? 'pointer' : 'normal'}
                  >
                    {cell.row.getIsExpanded() ? 'v' : '>'}
                    <FlexRender cell={cell} />
                    ({cell.row.subRows.length.toLocaleString()})
                  </button>
                {:else}
                  <FlexRender cell={cell} />
                {/if}
              </td>
            {/each}
          </tr>
        {/each}
        {#each table.getBottomRows() as row (row.id)}
          <tr class="pinned-row" style={pinnedRowStyle(row)}>
            {#each row.getVisibleCells() as cell (cell.id)}
              <td style={cellStyle(cell)} class={cellClass(cell)}>
                <FlexRender cell={cell} />
              </td>
            {/each}
          </tr>
        {/each}
      </tbody>
    </table>
  </div>

  <div class="spacer-sm"></div>
  <div class="controls">
    <button class="demo-button demo-button-sm" onclick={() => table.setPageIndex(0)} disabled={!table.getCanPreviousPage()}>{'<<'}</button>
    <button class="demo-button demo-button-sm" onclick={() => table.previousPage()} disabled={!table.getCanPreviousPage()}>{'<'}</button>
    <button class="demo-button demo-button-sm" onclick={() => table.nextPage()} disabled={!table.getCanNextPage()}>{'>'}</button>
    <button class="demo-button demo-button-sm" onclick={() => table.setPageIndex(table.getPageCount() - 1)} disabled={!table.getCanNextPage()}>{'>>'}</button>
    <span class="inline-controls">
      <div>Page</div>
      <strong>
        {(table.state.pagination.pageIndex + 1).toLocaleString()} of{' '}
        {table.getPageCount().toLocaleString()}
      </strong>
    </span>
    <span class="inline-controls">
      | Go to page:
      <input
        type="number"
        min="1"
        max={table.getPageCount()}
        value={table.state.pagination.pageIndex + 1}
        oninput={(event) => {
          const page = (event.target as HTMLInputElement).value
            ? Number((event.target as HTMLInputElement).value) - 1
            : 0
          table.setPageIndex(page)
        }}
        class="page-size-input"
      />
    </span>
    <select
      value={table.state.pagination.pageSize}
      onchange={(event) =>
        table.setPageSize(Number((event.target as HTMLSelectElement).value))}
    >
      {#each [10, 20, 30, 50, 100] as pageSize}
        <option value={pageSize}>Show {pageSize}</option>
      {/each}
    </select>
  </div>
  <div class="spacer-sm"></div>
  <div class="nowrap">
    {table.getRowModel().rows.length.toLocaleString()} rows on this page (
    {table.getFilteredRowModel().rows.length.toLocaleString()} filtered of{' '}
    {table.getCoreRowModel().rows.length.toLocaleString()} total)
  </div>
  <div class="spacer-md"></div>
  <details>
    <summary>Table state (live)</summary>
    <pre class="state-dump">{JSON.stringify(table.state, null, 2)}</pre>
  </details>
</div>

Docs
Cloudflare
Railway
CodeRabbit
Clerk
AG Grid
SerpAPI
WorkOS
Netlify
OpenRouter
Unkey
Electric
Sentry
Prisma
Cloudflare
Railway
CodeRabbit
Clerk
AG Grid
SerpAPI
WorkOS
Netlify
OpenRouter
Unkey
Electric
Sentry
Prisma
Table API Reference
Column API Reference
Row API Reference
Cell API Reference
Header API Reference
Features API Reference
Static Functions API Reference
Legacy API Reference

React Example: Kitchen Sink

import React from 'react'
import { TanStackDevtools } from '@tanstack/react-devtools'
import ReactDOM from 'react-dom/client'
import {
  Subscribe,
  aggregationFns,
  createColumnHelper,
  createExpandedRowModel,
  createFacetedMinMaxValues,
  createFacetedRowModel,
  createFacetedUniqueValues,
  createFilteredRowModel,
  createGroupedRowModel,
  createPaginatedRowModel,
  createSortedRowModel,
  filterFns,
  sortFns,
  stockFeatures,
  useTable,
} from '@tanstack/react-table'
import {
  tableDevtoolsPlugin,
  useTanStackTableDevtools,
} from '@tanstack/react-table-devtools'
import { compareItems, rankItem } from '@tanstack/match-sorter-utils'
import { useDebouncedCallback } from '@tanstack/react-pacer/debouncer'
import {
  DndContext,
  KeyboardSensor,
  MouseSensor,
  TouchSensor,
  closestCenter,
  useSensor,
  useSensors,
} from '@dnd-kit/core'
import { restrictToHorizontalAxis } from '@dnd-kit/modifiers'
import {
  SortableContext,
  arrayMove,
  horizontalListSortingStrategy,
  useSortable,
} from '@dnd-kit/sortable'
import { CSS } from '@dnd-kit/utilities'
import { makeData } from './makeData'
import type { CSSProperties, HTMLProps } from 'react'
import type { DragEndEvent } from '@dnd-kit/core'
import type { RankingInfo } from '@tanstack/match-sorter-utils'
import type { Person } from './makeData'
import type {
  Cell,
  CellData,
  Column,
  FilterFn,
  Header,
  ReactTable,
  Row,
  RowData,
  SortFn,
  TableFeatures,
} from '@tanstack/react-table'
import './index.css'

// =====================================================================
// Module augmentations
// =====================================================================

declare module '@tanstack/react-table' {
  interface ColumnMeta<
    TFeatures extends TableFeatures,
    TData extends RowData,
    TValue extends CellData = CellData,
  > {
    /** Per-column filter UI input variant. */
    filterVariant?: 'text' | 'range' | 'select'
  }
  interface FilterFns {
    fuzzy: FilterFn<typeof stockFeatures, Person>
  }
  interface FilterMeta {
    itemRank?: RankingInfo
  }
}

// =====================================================================
// Custom fuzzy filter / sort (from filters-fuzzy example)
// =====================================================================

const fuzzyFilter: FilterFn<typeof stockFeatures, Person> = (
  row,
  columnId,
  value,
  addMeta,
) => {
  const itemRank = rankItem(row.getValue(columnId), value)
  addMeta?.({ itemRank })
  return itemRank.passed
}

const fuzzySort: SortFn<typeof stockFeatures, Person> = (
  rowA,
  rowB,
  columnId,
) => {
  let dir = 0
  // eslint-disable-next-line @typescript-eslint/no-unnecessary-condition
  if (rowA.columnFiltersMeta[columnId]) {
    dir = compareItems(
      rowA.columnFiltersMeta[columnId].itemRank!,
      rowB.columnFiltersMeta[columnId].itemRank!,
    )
  }
  return dir === 0 ? sortFns.alphanumeric(rowA, rowB, columnId) : dir
}

// =====================================================================
// Custom status sort (from sorting example)
// =====================================================================

const sortStatusFn: SortFn<typeof stockFeatures, Person> = (rowA, rowB) => {
  const statusOrder = ['single', 'complicated', 'relationship']
  return (
    statusOrder.indexOf(rowA.original.status) -
    statusOrder.indexOf(rowB.original.status)
  )
}

// =====================================================================
// Sticky column-pinning helper (from column-pinning-sticky example)
// =====================================================================

const getCommonPinningStyles = (
  column: Column<typeof stockFeatures, Person>,
): CSSProperties => {
  const isPinned = column.getIsPinned()
  const isLastLeftPinnedColumn =
    isPinned === 'left' && column.getIsLastColumn('left')
  const isFirstRightPinnedColumn =
    isPinned === 'right' && column.getIsFirstColumn('right')

  return {
    boxShadow: isLastLeftPinnedColumn
      ? '-4px 0 4px -4px gray inset'
      : isFirstRightPinnedColumn
        ? '4px 0 4px -4px gray inset'
        : undefined,
    left: isPinned === 'left' ? `${column.getStart('left')}px` : undefined,
    right: isPinned === 'right' ? `${column.getAfter('right')}px` : undefined,
    opacity: isPinned ? 0.97 : 1,
    position: isPinned ? 'sticky' : 'relative',
    zIndex: isPinned ? 1 : 0,
  }
}

// =====================================================================
// Components: IndeterminateCheckbox, Filter, DebouncedInput,
//             DraggableTableHeader, DragAlongCell
// =====================================================================

function IndeterminateCheckbox({
  indeterminate,
  className = '',
  ...rest
}: { indeterminate?: boolean } & HTMLProps<HTMLInputElement>) {
  const ref = React.useRef<HTMLInputElement>(null!)

  React.useEffect(() => {
    if (typeof indeterminate === 'boolean') {
      ref.current.indeterminate = !rest.checked && indeterminate
    }
  }, [ref, indeterminate])

  return <input type="checkbox" ref={ref} className={className} {...rest} />
}

function DebouncedInput({
  value: initialValue,
  onChange,
  debounce = 300,
  ...props
}: {
  value: string | number
  onChange: (value: string | number) => void
  debounce?: number
} & Omit<React.InputHTMLAttributes<HTMLInputElement>, 'onChange'>) {
  const [value, setValue] = React.useState(initialValue)

  React.useEffect(() => {
    setValue(initialValue)
  }, [initialValue])

  const debouncedOnChange = useDebouncedCallback(onChange, { wait: debounce })

  return (
    <input
      {...props}
      value={value}
      onChange={(e) => {
        setValue(e.target.value)
        debouncedOnChange(e.target.value)
      }}
    />
  )
}

function Filter({ column }: { column: Column<typeof stockFeatures, Person> }) {
  const { filterVariant } = column.columnDef.meta ?? {}
  const columnFilterValue = column.getFilterValue()
  const minMaxValues =
    filterVariant === 'range' ? column.getFacetedMinMaxValues() : undefined

  const sortedUniqueValues = React.useMemo(
    () =>
      filterVariant === 'range'
        ? []
        : Array.from(column.getFacetedUniqueValues().keys())
            .sort()
            .slice(0, 5000),
    [column.getFacetedUniqueValues(), filterVariant],
  )

  return filterVariant === 'range' ? (
    <div className="filter-row">
      <DebouncedInput
        type="number"
        min={Number(minMaxValues?.[0] ?? '')}
        max={Number(minMaxValues?.[1] ?? '')}
        value={(columnFilterValue as [number, number] | undefined)?.[0] ?? ''}
        onChange={(value) =>
          column.setFilterValue((old: [number, number] | undefined) => [
            value,
            old?.[1],
          ])
        }
        placeholder={`Min${minMaxValues?.[0] !== undefined ? ` (${minMaxValues[0]})` : ''}`}
        className="filter-input"
      />
      <DebouncedInput
        type="number"
        min={Number(minMaxValues?.[0] ?? '')}
        max={Number(minMaxValues?.[1] ?? '')}
        value={(columnFilterValue as [number, number] | undefined)?.[1] ?? ''}
        onChange={(value) =>
          column.setFilterValue((old: [number, number] | undefined) => [
            old?.[0],
            value,
          ])
        }
        placeholder={`Max${minMaxValues?.[1] !== undefined ? ` (${minMaxValues[1]})` : ''}`}
        className="filter-input"
      />
    </div>
  ) : filterVariant === 'select' ? (
    <select
      onChange={(e) => column.setFilterValue(e.target.value)}
      value={(columnFilterValue ?? '').toString()}
      className="filter-select"
    >
      <option value="">All</option>
      {sortedUniqueValues.map((value) => (
        <option value={value} key={String(value)}>
          {String(value)}
        </option>
      ))}
    </select>
  ) : (
    <>
      <datalist id={column.id + 'list'}>
        {sortedUniqueValues.map((value) => (
          <option value={String(value)} key={String(value)} />
        ))}
      </datalist>
      <DebouncedInput
        type="text"
        value={(columnFilterValue ?? '') as string}
        onChange={(value) => column.setFilterValue(value)}
        placeholder={`Search (${column.getFacetedUniqueValues().size})`}
        className="filter-select"
        list={column.id + 'list'}
      />
    </>
  )
}

function DraggableTableHeader({
  header,
  table,
}: {
  header: Header<typeof stockFeatures, Person, unknown>
  table: ReactTable<typeof stockFeatures, Person>
}) {
  const { attributes, isDragging, listeners, setNodeRef, transform } =
    useSortable({ id: header.column.id })

  const column = header.column

  return (
    // work around react compiler memoization for nested components using table/column/header APIs
    <Subscribe
      source={table.store}
      selector={(state) => ({
        columnPinning: state.columnPinning,
        grouping: state.grouping,
        sorting: state.sorting,
      })}
    >
      {() => {
        const pinningStyles = getCommonPinningStyles(column)
        const style: CSSProperties = {
          ...pinningStyles,
          opacity: isDragging ? 0.8 : (pinningStyles.opacity ?? 1),
          transform: CSS.Translate.toString(transform),
          transition: 'width transform 0.2s ease-in-out',
          whiteSpace: 'nowrap',
          width: `calc(var(--header-${header.id}-size) * 1px)`,
          zIndex: isDragging ? 2 : pinningStyles.zIndex,
        }

        if (header.isPlaceholder) {
          return <th ref={setNodeRef} style={style} colSpan={header.colSpan} />
        }

        return (
          <th ref={setNodeRef} style={style} colSpan={header.colSpan}>
            <div className="header-row">
              {column.id !== 'select' ? (
                <button
                  className="drag-handle"
                  type="button"
                  {...attributes}
                  {...listeners}
                  title="Drag to reorder"
                >

                </button>
              ) : null}
              <div style={{ flex: 1, minWidth: 0 }}>
                <div className="header-controls">
                  {column.getCanPin() ? (
                    <span className="pin-actions">
                      {column.getIsPinned() !== 'left' ? (
                        <button
                          className="pin-button"
                          onClick={() => column.pin('left')}
                          title="Pin left"
                        >

                        </button>
                      ) : null}
                      {column.getIsPinned() ? (
                        <button
                          className="pin-button"
                          onClick={() => column.pin(false)}
                          title="Unpin"
                        >
                          ×
                        </button>
                      ) : null}
                      {column.getIsPinned() !== 'right' ? (
                        <button
                          className="pin-button"
                          onClick={() => column.pin('right')}
                          title="Pin right"
                        >

                        </button>
                      ) : null}
                    </span>
                  ) : null}
                  {column.getCanGroup() ? (
                    <button
                      className="pin-button"
                      onClick={column.getToggleGroupingHandler()}
                      title={
                        column.getIsGrouped()
                          ? 'Stop grouping by this column'
                          : 'Group by this column'
                      }
                    >
                      {column.getIsGrouped()
                        ? `🛑(${column.getGroupedIndex()})`
                        : '👊'}
                    </button>
                  ) : null}
                </div>
                {column.getCanSort() ? (
                  <button
                    type="button"
                    className="sortable-header"
                    onClick={column.getToggleSortingHandler()}
                    title={
                      column.getNextSortingOrder() === 'asc'
                        ? 'Sort ascending'
                        : column.getNextSortingOrder() === 'desc'
                          ? 'Sort descending'
                          : 'Clear sort'
                    }
                  >
                    <table.FlexRender header={header} />
                    {{
                      asc: ' 🔼',
                      desc: ' 🔽',
                    }[column.getIsSorted() as string] ?? null}
                  </button>
                ) : (
                  <table.FlexRender header={header} />
                )}
                {column.getCanFilter() ? (
                  <div>
                    <Filter column={column} />
                  </div>
                ) : null}
              </div>
            </div>
            {column.getCanResize() ? (
              <div
                onDoubleClick={() => column.resetSize()}
                onMouseDown={header.getResizeHandler()}
                onTouchStart={header.getResizeHandler()}
                className={`resizer ${column.getIsResizing() ? 'isResizing' : ''}`}
              />
            ) : null}
          </th>
        )
      }}
    </Subscribe>
  )
}

function DragAlongCell({
  cell,
  table,
}: {
  cell: Cell<typeof stockFeatures, Person, unknown>
  table: ReactTable<typeof stockFeatures, Person>
}) {
  const { isDragging, setNodeRef, transform } = useSortable({
    id: cell.column.id,
  })

  const pinningStyles = getCommonPinningStyles(cell.column)
  const style: CSSProperties = {
    ...pinningStyles,
    opacity: isDragging ? 0.8 : (pinningStyles.opacity ?? 1),
    transform: CSS.Translate.toString(transform),
    transition: 'width transform 0.2s ease-in-out',
    width: `calc(var(--col-${cell.column.id}-size) * 1px)`,
    zIndex: isDragging ? 2 : pinningStyles.zIndex,
  }

  // Highlight grouped/aggregated/placeholder cells only when grouping is
  // active AND the column actually participates in aggregation. This keeps
  // display columns (selection, row pin) styled normally even on synthetic
  // parent group rows, and prevents the implicit "parent has subRows"
  // aggregated highlight from showing on plain nested data.
  const groupingActive = table.state.grouping.length > 0
  const hasAggregation = !!cell.column.columnDef.aggregationFn
  const className = !groupingActive
    ? undefined
    : cell.getIsGrouped()
      ? 'cell-grouped'
      : hasAggregation && cell.getIsAggregated()
        ? 'cell-aggregated'
        : cell.getIsPlaceholder()
          ? 'cell-placeholder'
          : undefined

  // FlexRender now handles aggregatedCell / placeholder dispatch internally
  // (returns null for placeholders, picks aggregatedCell when available).
  // The only state we still wrap manually is the grouped-cell expander —
  // that's UI specific to this example.
  return (
    <td ref={setNodeRef} style={style} className={className}>
      {cell.getIsGrouped() ? (
        <button
          onClick={cell.row.getToggleExpandedHandler()}
          style={{ cursor: cell.row.getCanExpand() ? 'pointer' : 'normal' }}
        >
          {cell.row.getIsExpanded() ? '👇' : '👉'}{' '}
          <table.FlexRender cell={cell} /> (
          {cell.row.subRows.length.toLocaleString()})
        </button>
      ) : (
        <table.FlexRender cell={cell} />
      )}
    </td>
  )
}

// =====================================================================
// Pinned row (sticky positioning at top/bottom)
// =====================================================================

function PinnedRow({
  row,
  table,
}: {
  row: Row<typeof stockFeatures, Person>
  table: ReactTable<typeof stockFeatures, Person>
}) {
  const bottomRows = table.getBottomRows()
  return (
    <tr
      className="pinned-row"
      style={{
        position: 'sticky',
        top:
          row.getIsPinned() === 'top'
            ? `${row.getPinnedIndex() * 32 + 48}px`
            : undefined,
        bottom:
          row.getIsPinned() === 'bottom'
            ? `${(bottomRows.length - 1 - row.getPinnedIndex()) * 32}px`
            : undefined,
        zIndex: 1,
      }}
    >
      {row.getVisibleCells().map((cell) => (
        <SortableContext
          key={cell.id}
          items={table.state.columnOrder}
          strategy={horizontalListSortingStrategy}
        >
          <DragAlongCell key={cell.id} cell={cell} table={table} />
        </SortableContext>
      ))}
    </tr>
  )
}

// =====================================================================
// Main app
// =====================================================================

function App() {
  const rerender = React.useReducer(() => ({}), {})[1]

  const columns = React.useMemo(() => {
    const columnHelper = createColumnHelper<typeof stockFeatures, Person>()
    return columnHelper.columns([
      columnHelper.display({
        id: 'select',
        size: 80,
        minSize: 80,
        maxSize: 80,
        enableSorting: false,
        enableGrouping: false,
        enableHiding: false,
        enableResizing: false,
        header: ({ table }) => (
          // work around react compiler memoization for nested components using table APIs
          <Subscribe source={table.atoms.rowSelection}>
            {() => (
              <IndeterminateCheckbox
                checked={table.getIsAllPageRowsSelected()}
                indeterminate={table.getIsSomePageRowsSelected()}
                onChange={table.getToggleAllPageRowsSelectedHandler()}
                title="Select all on this page"
              />
            )}
          </Subscribe>
        ),
        cell: ({ row, table }) => (
          // work around react compiler memoization for nested components using row APIs
          <Subscribe
            source={table.store}
            selector={(s) => ({
              rowSelection: s.rowSelection,
              rowPinning: s.rowPinning,
            })}
          >
            {() => (
              <div className="column-toggle-row">
                <IndeterminateCheckbox
                  checked={row.getIsSelected()}
                  disabled={!row.getCanSelect()}
                  indeterminate={row.getIsSomeSelected()}
                  onChange={row.getToggleSelectedHandler()}
                />{' '}
                <button
                  className="pin-button"
                  onClick={() =>
                    row.pin(row.getIsPinned() === 'top' ? false : 'top')
                  }
                  title={
                    row.getIsPinned() === 'top' ? 'Unpin row' : 'Pin row top'
                  }
                >
                  {row.getIsPinned() === 'top' ? '📌' : '📍'}
                </button>
              </div>
            )}
          </Subscribe>
        ),
      }),
      columnHelper.accessor('firstName', {
        id: 'firstName',
        size: 200,
        header: 'First Name',
        filterFn: 'fuzzy',
        sortFn: fuzzySort,
        meta: { filterVariant: 'text' },
        // override grouping value so first+last combine as a group key
        getGroupingValue: (row) => `${row.firstName} ${row.lastName}`,
        cell: ({ row, getValue }) => (
          <div style={{ paddingLeft: `${row.depth * 1.5}rem` }}>
            {row.getCanExpand() ? (
              <button
                onClick={row.getToggleExpandedHandler()}
                style={{ cursor: 'pointer', marginRight: '0.25rem' }}
              >
                {row.getIsExpanded() ? '👇' : '👉'}
              </button>
            ) : (
              <span style={{ marginRight: '0.25rem' }}>·</span>
            )}
            {String(getValue())}
          </div>
        ),
      }),
      columnHelper.accessor((row) => row.lastName, {
        id: 'lastName',
        size: 180,
        header: 'Last Name',
        meta: { filterVariant: 'text' },
      }),
      columnHelper.accessor('age', {
        id: 'age',
        size: 200,
        header: 'Age',
        meta: { filterVariant: 'range' },
        aggregationFn: 'median',
        aggregatedCell: ({ getValue }) =>
          Math.round(getValue<number>() * 100) / 100,
      }),
      columnHelper.accessor('visits', {
        id: 'visits',
        size: 200,
        header: 'Visits',
        meta: { filterVariant: 'range' },
        aggregationFn: 'sum',
        aggregatedCell: ({ getValue }) => getValue<number>().toLocaleString(),
      }),
      columnHelper.accessor('status', {
        id: 'status',
        size: 200,
        header: 'Status',
        sortFn: sortStatusFn,
        meta: { filterVariant: 'select' },
      }),
      columnHelper.accessor('progress', {
        id: 'progress',
        size: 200,
        header: 'Profile Progress',
        meta: { filterVariant: 'range' },
        aggregationFn: 'mean',
        cell: ({ getValue }) =>
          `${Math.round(getValue<number>() * 100) / 100}%`,
        aggregatedCell: ({ getValue }) =>
          `${Math.round(getValue<number>() * 100) / 100}%`,
      }),
    ])
  }, [])

  const [data, setData] = React.useState(() => makeData(1_000))
  const refreshData = () => setData(makeData(1_000))
  const nestedData = () => setData(makeData(100, 5, 3))
  const stress10k = () => setData(makeData(10_000))
  const stress100k = () => setData(makeData(100_000))

  const table = useTable(
    {
      key: 'kitchen-sink', // needed for devtools
      features: stockFeatures,
      rowModels: {
        expandedRowModel: createExpandedRowModel(),
        filteredRowModel: createFilteredRowModel({
          ...filterFns,
          fuzzy: fuzzyFilter,
        }),
        facetedRowModel: createFacetedRowModel(),
        facetedMinMaxValues: createFacetedMinMaxValues(),
        facetedUniqueValues: createFacetedUniqueValues(),
        groupedRowModel: createGroupedRowModel(aggregationFns),
        paginatedRowModel: createPaginatedRowModel(),
        sortedRowModel: createSortedRowModel(sortFns),
      },
      columns,
      data,
      getSubRows: (row) => row.subRows,
      globalFilterFn: 'fuzzy',
      columnResizeMode: 'onChange',
      defaultColumn: { minSize: 200, maxSize: 800 },
      initialState: {
        columnOrder: columns.map((c) => c.id!),
        columnPinning: { left: ['select'], right: [] },
        pagination: { pageIndex: 0, pageSize: 20 },
      },
      keepPinnedRows: true,
      debugTable: true,
    },
    (state) => state, // default selector
  )

  useTanStackTableDevtools(table)

  // memoized column-size css variables (column-resizing-performant pattern)
  const columnSizeVars = React.useMemo(() => {
    const headers = table.getFlatHeaders()
    const colSizes: Record<string, number> = {}
    for (let i = 0; i < headers.length; i++) {
      const header = headers[i]
      colSizes[`--header-${header.id}-size`] = header.getSize()
      colSizes[`--col-${header.column.id}-size`] = header.column.getSize()
    }
    return colSizes
  }, [table.state.columnResizing, table.state.columnSizing])

  // DnD column reordering
  const handleDragEnd = (event: DragEndEvent) => {
    const { active, over } = event
    if (over && active.id !== over.id) {
      table.setColumnOrder((prev) => {
        const oldIndex = prev.indexOf(active.id as string)
        const newIndex = prev.indexOf(over.id as string)
        return arrayMove(prev, oldIndex, newIndex)
      })
    }
  }

  const sensors = useSensors(
    useSensor(MouseSensor, {}),
    useSensor(TouchSensor, {}),
    useSensor(KeyboardSensor, {}),
  )

  const selectedCount = table.getSelectedRowModel().flatRows.length

  return (
    <DndContext
      collisionDetection={closestCenter}
      modifiers={[restrictToHorizontalAxis]}
      onDragEnd={handleDragEnd}
      sensors={sensors}
    >
      <div className="demo-root">
        <h1>Kitchen Sink — All Features</h1>

        {/* Toolbar */}
        <div className="toolbar">
          <div className="toolbar-row">
            <DebouncedInput
              value={(table.state.globalFilter ?? '') as string}
              onChange={(value) => table.setGlobalFilter(String(value))}
              className="global-filter-input"
              placeholder="Fuzzy search all columns..."
            />
          </div>
          <div className="toolbar-row">
            <button
              onClick={refreshData}
              className="demo-button demo-button-sm"
            >
              Flat 1k
            </button>
            <button onClick={nestedData} className="demo-button demo-button-sm">
              Nested 100×5×3
            </button>
            <button onClick={stress10k} className="demo-button demo-button-sm">
              Stress 10k (flat)
            </button>
            <button onClick={stress100k} className="demo-button demo-button-sm">
              Stress 100k (flat)
            </button>
            <button
              onClick={() => table.reset()}
              className="demo-button demo-button-sm"
            >
              Reset Table
            </button>
            <button
              onClick={() => rerender()}
              className="demo-button demo-button-sm"
            >
              Force Rerender
            </button>
            <span className="nowrap">
              {selectedCount.toLocaleString()} of{' '}
              {table.getCoreRowModel().flatRows.length.toLocaleString()}{' '}
              selected
            </span>
          </div>
          <details className="column-toggle-panel">
            <summary className="column-toggle-panel-header">
              Column visibility
            </summary>
            <div className="column-toggle-row">
              <label>
                <input
                  type="checkbox"
                  checked={table.getIsAllColumnsVisible()}
                  onChange={table.getToggleAllColumnsVisibilityHandler()}
                />{' '}
                Toggle All
              </label>
            </div>
            {table.getAllLeafColumns().map((column) => (
              <div key={column.id} className="column-toggle-row">
                <label>
                  <input
                    type="checkbox"
                    checked={column.getIsVisible()}
                    disabled={!column.getCanHide()}
                    onChange={column.getToggleVisibilityHandler()}
                  />{' '}
                  {column.id}
                </label>
              </div>
            ))}
          </details>
        </div>

        {/* Table */}
        <div className="table-container">
          <table style={{ ...columnSizeVars, width: table.getTotalSize() }}>
            <thead>
              {table.getHeaderGroups().map((headerGroup) => (
                <tr key={headerGroup.id}>
                  <SortableContext
                    items={table.state.columnOrder}
                    strategy={horizontalListSortingStrategy}
                  >
                    {headerGroup.headers.map((header) => (
                      <DraggableTableHeader
                        key={header.id}
                        header={header}
                        table={table}
                      />
                    ))}
                  </SortableContext>
                </tr>
              ))}
            </thead>
            <tbody>
              {table.getTopRows().map((row) => (
                <PinnedRow key={row.id} row={row} table={table} />
              ))}
              {table.getCenterRows().map((row) => (
                <tr key={row.id}>
                  {row.getVisibleCells().map((cell) => (
                    <SortableContext
                      key={cell.id}
                      items={table.state.columnOrder}
                      strategy={horizontalListSortingStrategy}
                    >
                      <DragAlongCell key={cell.id} cell={cell} table={table} />
                    </SortableContext>
                  ))}
                </tr>
              ))}
              {table.getBottomRows().map((row) => (
                <PinnedRow key={row.id} row={row} table={table} />
              ))}
            </tbody>
          </table>
        </div>

        {/* Pagination */}
        <div className="spacer-sm" />
        <div className="controls">
          <button
            className="demo-button demo-button-sm"
            onClick={() => table.setPageIndex(0)}
            disabled={!table.getCanPreviousPage()}
          >
            {'<<'}
          </button>
          <button
            className="demo-button demo-button-sm"
            onClick={() => table.previousPage()}
            disabled={!table.getCanPreviousPage()}
          >
            {'<'}
          </button>
          <button
            className="demo-button demo-button-sm"
            onClick={() => table.nextPage()}
            disabled={!table.getCanNextPage()}
          >
            {'>'}
          </button>
          <button
            className="demo-button demo-button-sm"
            onClick={() => table.setPageIndex(table.getPageCount() - 1)}
            disabled={!table.getCanNextPage()}
          >
            {'>>'}
          </button>
          <span className="inline-controls">
            <div>Page</div>
            <strong>
              {(table.state.pagination.pageIndex + 1).toLocaleString()} of{' '}
              {table.getPageCount().toLocaleString()}
            </strong>
          </span>
          <span className="inline-controls">
            | Go to page:
            <input
              type="number"
              min="1"
              max={table.getPageCount()}
              defaultValue={table.state.pagination.pageIndex + 1}
              onChange={(e) => {
                const page = e.target.value ? Number(e.target.value) - 1 : 0
                table.setPageIndex(page)
              }}
              className="page-size-input"
            />
          </span>
          <select
            value={table.state.pagination.pageSize}
            onChange={(e) => table.setPageSize(Number(e.target.value))}
          >
            {[10, 20, 30, 50, 100].map((pageSize) => (
              <option key={pageSize} value={pageSize}>
                Show {pageSize}
              </option>
            ))}
          </select>
        </div>
        <div className="spacer-sm" />
        <div className="nowrap">
          {table.getRowModel().rows.length.toLocaleString()} rows on this page (
          {table.getFilteredRowModel().rows.length.toLocaleString()} filtered of{' '}
          {table.getCoreRowModel().rows.length.toLocaleString()} total)
        </div>
        <div className="spacer-md" />
        <details>
          <summary>Table state (live)</summary>
          <pre className="state-dump">
            {JSON.stringify(table.state, null, 2)}
          </pre>
        </details>
      </div>
    </DndContext>
  )
}

const rootElement = document.getElementById('root')
if (!rootElement) throw new Error('Failed to find the root element')

ReactDOM.createRoot(rootElement).render(
  <React.StrictMode>
    <App />
    <TanStackDevtools plugins={[tableDevtoolsPlugin()]} />
  </React.StrictMode>,
)
import React from 'react'
import { TanStackDevtools } from '@tanstack/react-devtools'
import ReactDOM from 'react-dom/client'
import {
  Subscribe,
  aggregationFns,
  createColumnHelper,
  createExpandedRowModel,
  createFacetedMinMaxValues,
  createFacetedRowModel,
  createFacetedUniqueValues,
  createFilteredRowModel,
  createGroupedRowModel,
  createPaginatedRowModel,
  createSortedRowModel,
  filterFns,
  sortFns,
  stockFeatures,
  useTable,
} from '@tanstack/react-table'
import {
  tableDevtoolsPlugin,
  useTanStackTableDevtools,
} from '@tanstack/react-table-devtools'
import { compareItems, rankItem } from '@tanstack/match-sorter-utils'
import { useDebouncedCallback } from '@tanstack/react-pacer/debouncer'
import {
  DndContext,
  KeyboardSensor,
  MouseSensor,
  TouchSensor,
  closestCenter,
  useSensor,
  useSensors,
} from '@dnd-kit/core'
import { restrictToHorizontalAxis } from '@dnd-kit/modifiers'
import {
  SortableContext,
  arrayMove,
  horizontalListSortingStrategy,
  useSortable,
} from '@dnd-kit/sortable'
import { CSS } from '@dnd-kit/utilities'
import { makeData } from './makeData'
import type { CSSProperties, HTMLProps } from 'react'
import type { DragEndEvent } from '@dnd-kit/core'
import type { RankingInfo } from '@tanstack/match-sorter-utils'
import type { Person } from './makeData'
import type {
  Cell,
  CellData,
  Column,
  FilterFn,
  Header,
  ReactTable,
  Row,
  RowData,
  SortFn,
  TableFeatures,
} from '@tanstack/react-table'
import './index.css'

// =====================================================================
// Module augmentations
// =====================================================================

declare module '@tanstack/react-table' {
  interface ColumnMeta<
    TFeatures extends TableFeatures,
    TData extends RowData,
    TValue extends CellData = CellData,
  > {
    /** Per-column filter UI input variant. */
    filterVariant?: 'text' | 'range' | 'select'
  }
  interface FilterFns {
    fuzzy: FilterFn<typeof stockFeatures, Person>
  }
  interface FilterMeta {
    itemRank?: RankingInfo
  }
}

// =====================================================================
// Custom fuzzy filter / sort (from filters-fuzzy example)
// =====================================================================

const fuzzyFilter: FilterFn<typeof stockFeatures, Person> = (
  row,
  columnId,
  value,
  addMeta,
) => {
  const itemRank = rankItem(row.getValue(columnId), value)
  addMeta?.({ itemRank })
  return itemRank.passed
}

const fuzzySort: SortFn<typeof stockFeatures, Person> = (
  rowA,
  rowB,
  columnId,
) => {
  let dir = 0
  // eslint-disable-next-line @typescript-eslint/no-unnecessary-condition
  if (rowA.columnFiltersMeta[columnId]) {
    dir = compareItems(
      rowA.columnFiltersMeta[columnId].itemRank!,
      rowB.columnFiltersMeta[columnId].itemRank!,
    )
  }
  return dir === 0 ? sortFns.alphanumeric(rowA, rowB, columnId) : dir
}

// =====================================================================
// Custom status sort (from sorting example)
// =====================================================================

const sortStatusFn: SortFn<typeof stockFeatures, Person> = (rowA, rowB) => {
  const statusOrder = ['single', 'complicated', 'relationship']
  return (
    statusOrder.indexOf(rowA.original.status) -
    statusOrder.indexOf(rowB.original.status)
  )
}

// =====================================================================
// Sticky column-pinning helper (from column-pinning-sticky example)
// =====================================================================

const getCommonPinningStyles = (
  column: Column<typeof stockFeatures, Person>,
): CSSProperties => {
  const isPinned = column.getIsPinned()
  const isLastLeftPinnedColumn =
    isPinned === 'left' && column.getIsLastColumn('left')
  const isFirstRightPinnedColumn =
    isPinned === 'right' && column.getIsFirstColumn('right')

  return {
    boxShadow: isLastLeftPinnedColumn
      ? '-4px 0 4px -4px gray inset'
      : isFirstRightPinnedColumn
        ? '4px 0 4px -4px gray inset'
        : undefined,
    left: isPinned === 'left' ? `${column.getStart('left')}px` : undefined,
    right: isPinned === 'right' ? `${column.getAfter('right')}px` : undefined,
    opacity: isPinned ? 0.97 : 1,
    position: isPinned ? 'sticky' : 'relative',
    zIndex: isPinned ? 1 : 0,
  }
}

// =====================================================================
// Components: IndeterminateCheckbox, Filter, DebouncedInput,
//             DraggableTableHeader, DragAlongCell
// =====================================================================

function IndeterminateCheckbox({
  indeterminate,
  className = '',
  ...rest
}: { indeterminate?: boolean } & HTMLProps<HTMLInputElement>) {
  const ref = React.useRef<HTMLInputElement>(null!)

  React.useEffect(() => {
    if (typeof indeterminate === 'boolean') {
      ref.current.indeterminate = !rest.checked && indeterminate
    }
  }, [ref, indeterminate])

  return <input type="checkbox" ref={ref} className={className} {...rest} />
}

function DebouncedInput({
  value: initialValue,
  onChange,
  debounce = 300,
  ...props
}: {
  value: string | number
  onChange: (value: string | number) => void
  debounce?: number
} & Omit<React.InputHTMLAttributes<HTMLInputElement>, 'onChange'>) {
  const [value, setValue] = React.useState(initialValue)

  React.useEffect(() => {
    setValue(initialValue)
  }, [initialValue])

  const debouncedOnChange = useDebouncedCallback(onChange, { wait: debounce })

  return (
    <input
      {...props}
      value={value}
      onChange={(e) => {
        setValue(e.target.value)
        debouncedOnChange(e.target.value)
      }}
    />
  )
}

function Filter({ column }: { column: Column<typeof stockFeatures, Person> }) {
  const { filterVariant } = column.columnDef.meta ?? {}
  const columnFilterValue = column.getFilterValue()
  const minMaxValues =
    filterVariant === 'range' ? column.getFacetedMinMaxValues() : undefined

  const sortedUniqueValues = React.useMemo(
    () =>
      filterVariant === 'range'
        ? []
        : Array.from(column.getFacetedUniqueValues().keys())
            .sort()
            .slice(0, 5000),
    [column.getFacetedUniqueValues(), filterVariant],
  )

  return filterVariant === 'range' ? (
    <div className="filter-row">
      <DebouncedInput
        type="number"
        min={Number(minMaxValues?.[0] ?? '')}
        max={Number(minMaxValues?.[1] ?? '')}
        value={(columnFilterValue as [number, number] | undefined)?.[0] ?? ''}
        onChange={(value) =>
          column.setFilterValue((old: [number, number] | undefined) => [
            value,
            old?.[1],
          ])
        }
        placeholder={`Min${minMaxValues?.[0] !== undefined ? ` (${minMaxValues[0]})` : ''}`}
        className="filter-input"
      />
      <DebouncedInput
        type="number"
        min={Number(minMaxValues?.[0] ?? '')}
        max={Number(minMaxValues?.[1] ?? '')}
        value={(columnFilterValue as [number, number] | undefined)?.[1] ?? ''}
        onChange={(value) =>
          column.setFilterValue((old: [number, number] | undefined) => [
            old?.[0],
            value,
          ])
        }
        placeholder={`Max${minMaxValues?.[1] !== undefined ? ` (${minMaxValues[1]})` : ''}`}
        className="filter-input"
      />
    </div>
  ) : filterVariant === 'select' ? (
    <select
      onChange={(e) => column.setFilterValue(e.target.value)}
      value={(columnFilterValue ?? '').toString()}
      className="filter-select"
    >
      <option value="">All</option>
      {sortedUniqueValues.map((value) => (
        <option value={value} key={String(value)}>
          {String(value)}
        </option>
      ))}
    </select>
  ) : (
    <>
      <datalist id={column.id + 'list'}>
        {sortedUniqueValues.map((value) => (
          <option value={String(value)} key={String(value)} />
        ))}
      </datalist>
      <DebouncedInput
        type="text"
        value={(columnFilterValue ?? '') as string}
        onChange={(value) => column.setFilterValue(value)}
        placeholder={`Search (${column.getFacetedUniqueValues().size})`}
        className="filter-select"
        list={column.id + 'list'}
      />
    </>
  )
}

function DraggableTableHeader({
  header,
  table,
}: {
  header: Header<typeof stockFeatures, Person, unknown>
  table: ReactTable<typeof stockFeatures, Person>
}) {
  const { attributes, isDragging, listeners, setNodeRef, transform } =
    useSortable({ id: header.column.id })

  const column = header.column

  return (
    // work around react compiler memoization for nested components using table/column/header APIs
    <Subscribe
      source={table.store}
      selector={(state) => ({
        columnPinning: state.columnPinning,
        grouping: state.grouping,
        sorting: state.sorting,
      })}
    >
      {() => {
        const pinningStyles = getCommonPinningStyles(column)
        const style: CSSProperties = {
          ...pinningStyles,
          opacity: isDragging ? 0.8 : (pinningStyles.opacity ?? 1),
          transform: CSS.Translate.toString(transform),
          transition: 'width transform 0.2s ease-in-out',
          whiteSpace: 'nowrap',
          width: `calc(var(--header-${header.id}-size) * 1px)`,
          zIndex: isDragging ? 2 : pinningStyles.zIndex,
        }

        if (header.isPlaceholder) {
          return <th ref={setNodeRef} style={style} colSpan={header.colSpan} />
        }

        return (
          <th ref={setNodeRef} style={style} colSpan={header.colSpan}>
            <div className="header-row">
              {column.id !== 'select' ? (
                <button
                  className="drag-handle"
                  type="button"
                  {...attributes}
                  {...listeners}
                  title="Drag to reorder"
                >

                </button>
              ) : null}
              <div style={{ flex: 1, minWidth: 0 }}>
                <div className="header-controls">
                  {column.getCanPin() ? (
                    <span className="pin-actions">
                      {column.getIsPinned() !== 'left' ? (
                        <button
                          className="pin-button"
                          onClick={() => column.pin('left')}
                          title="Pin left"
                        >

                        </button>
                      ) : null}
                      {column.getIsPinned() ? (
                        <button
                          className="pin-button"
                          onClick={() => column.pin(false)}
                          title="Unpin"
                        >
                          ×
                        </button>
                      ) : null}
                      {column.getIsPinned() !== 'right' ? (
                        <button
                          className="pin-button"
                          onClick={() => column.pin('right')}
                          title="Pin right"
                        >

                        </button>
                      ) : null}
                    </span>
                  ) : null}
                  {column.getCanGroup() ? (
                    <button
                      className="pin-button"
                      onClick={column.getToggleGroupingHandler()}
                      title={
                        column.getIsGrouped()
                          ? 'Stop grouping by this column'
                          : 'Group by this column'
                      }
                    >
                      {column.getIsGrouped()
                        ? `🛑(${column.getGroupedIndex()})`
                        : '👊'}
                    </button>
                  ) : null}
                </div>
                {column.getCanSort() ? (
                  <button
                    type="button"
                    className="sortable-header"
                    onClick={column.getToggleSortingHandler()}
                    title={
                      column.getNextSortingOrder() === 'asc'
                        ? 'Sort ascending'
                        : column.getNextSortingOrder() === 'desc'
                          ? 'Sort descending'
                          : 'Clear sort'
                    }
                  >
                    <table.FlexRender header={header} />
                    {{
                      asc: ' 🔼',
                      desc: ' 🔽',
                    }[column.getIsSorted() as string] ?? null}
                  </button>
                ) : (
                  <table.FlexRender header={header} />
                )}
                {column.getCanFilter() ? (
                  <div>
                    <Filter column={column} />
                  </div>
                ) : null}
              </div>
            </div>
            {column.getCanResize() ? (
              <div
                onDoubleClick={() => column.resetSize()}
                onMouseDown={header.getResizeHandler()}
                onTouchStart={header.getResizeHandler()}
                className={`resizer ${column.getIsResizing() ? 'isResizing' : ''}`}
              />
            ) : null}
          </th>
        )
      }}
    </Subscribe>
  )
}

function DragAlongCell({
  cell,
  table,
}: {
  cell: Cell<typeof stockFeatures, Person, unknown>
  table: ReactTable<typeof stockFeatures, Person>
}) {
  const { isDragging, setNodeRef, transform } = useSortable({
    id: cell.column.id,
  })

  const pinningStyles = getCommonPinningStyles(cell.column)
  const style: CSSProperties = {
    ...pinningStyles,
    opacity: isDragging ? 0.8 : (pinningStyles.opacity ?? 1),
    transform: CSS.Translate.toString(transform),
    transition: 'width transform 0.2s ease-in-out',
    width: `calc(var(--col-${cell.column.id}-size) * 1px)`,
    zIndex: isDragging ? 2 : pinningStyles.zIndex,
  }

  // Highlight grouped/aggregated/placeholder cells only when grouping is
  // active AND the column actually participates in aggregation. This keeps
  // display columns (selection, row pin) styled normally even on synthetic
  // parent group rows, and prevents the implicit "parent has subRows"
  // aggregated highlight from showing on plain nested data.
  const groupingActive = table.state.grouping.length > 0
  const hasAggregation = !!cell.column.columnDef.aggregationFn
  const className = !groupingActive
    ? undefined
    : cell.getIsGrouped()
      ? 'cell-grouped'
      : hasAggregation && cell.getIsAggregated()
        ? 'cell-aggregated'
        : cell.getIsPlaceholder()
          ? 'cell-placeholder'
          : undefined

  // FlexRender now handles aggregatedCell / placeholder dispatch internally
  // (returns null for placeholders, picks aggregatedCell when available).
  // The only state we still wrap manually is the grouped-cell expander —
  // that's UI specific to this example.
  return (
    <td ref={setNodeRef} style={style} className={className}>
      {cell.getIsGrouped() ? (
        <button
          onClick={cell.row.getToggleExpandedHandler()}
          style={{ cursor: cell.row.getCanExpand() ? 'pointer' : 'normal' }}
        >
          {cell.row.getIsExpanded() ? '👇' : '👉'}{' '}
          <table.FlexRender cell={cell} /> (
          {cell.row.subRows.length.toLocaleString()})
        </button>
      ) : (
        <table.FlexRender cell={cell} />
      )}
    </td>
  )
}

// =====================================================================
// Pinned row (sticky positioning at top/bottom)
// =====================================================================

function PinnedRow({
  row,
  table,
}: {
  row: Row<typeof stockFeatures, Person>
  table: ReactTable<typeof stockFeatures, Person>
}) {
  const bottomRows = table.getBottomRows()
  return (
    <tr
      className="pinned-row"
      style={{
        position: 'sticky',
        top:
          row.getIsPinned() === 'top'
            ? `${row.getPinnedIndex() * 32 + 48}px`
            : undefined,
        bottom:
          row.getIsPinned() === 'bottom'
            ? `${(bottomRows.length - 1 - row.getPinnedIndex()) * 32}px`
            : undefined,
        zIndex: 1,
      }}
    >
      {row.getVisibleCells().map((cell) => (
        <SortableContext
          key={cell.id}
          items={table.state.columnOrder}
          strategy={horizontalListSortingStrategy}
        >
          <DragAlongCell key={cell.id} cell={cell} table={table} />
        </SortableContext>
      ))}
    </tr>
  )
}

// =====================================================================
// Main app
// =====================================================================

function App() {
  const rerender = React.useReducer(() => ({}), {})[1]

  const columns = React.useMemo(() => {
    const columnHelper = createColumnHelper<typeof stockFeatures, Person>()
    return columnHelper.columns([
      columnHelper.display({
        id: 'select',
        size: 80,
        minSize: 80,
        maxSize: 80,
        enableSorting: false,
        enableGrouping: false,
        enableHiding: false,
        enableResizing: false,
        header: ({ table }) => (
          // work around react compiler memoization for nested components using table APIs
          <Subscribe source={table.atoms.rowSelection}>
            {() => (
              <IndeterminateCheckbox
                checked={table.getIsAllPageRowsSelected()}
                indeterminate={table.getIsSomePageRowsSelected()}
                onChange={table.getToggleAllPageRowsSelectedHandler()}
                title="Select all on this page"
              />
            )}
          </Subscribe>
        ),
        cell: ({ row, table }) => (
          // work around react compiler memoization for nested components using row APIs
          <Subscribe
            source={table.store}
            selector={(s) => ({
              rowSelection: s.rowSelection,
              rowPinning: s.rowPinning,
            })}
          >
            {() => (
              <div className="column-toggle-row">
                <IndeterminateCheckbox
                  checked={row.getIsSelected()}
                  disabled={!row.getCanSelect()}
                  indeterminate={row.getIsSomeSelected()}
                  onChange={row.getToggleSelectedHandler()}
                />{' '}
                <button
                  className="pin-button"
                  onClick={() =>
                    row.pin(row.getIsPinned() === 'top' ? false : 'top')
                  }
                  title={
                    row.getIsPinned() === 'top' ? 'Unpin row' : 'Pin row top'
                  }
                >
                  {row.getIsPinned() === 'top' ? '📌' : '📍'}
                </button>
              </div>
            )}
          </Subscribe>
        ),
      }),
      columnHelper.accessor('firstName', {
        id: 'firstName',
        size: 200,
        header: 'First Name',
        filterFn: 'fuzzy',
        sortFn: fuzzySort,
        meta: { filterVariant: 'text' },
        // override grouping value so first+last combine as a group key
        getGroupingValue: (row) => `${row.firstName} ${row.lastName}`,
        cell: ({ row, getValue }) => (
          <div style={{ paddingLeft: `${row.depth * 1.5}rem` }}>
            {row.getCanExpand() ? (
              <button
                onClick={row.getToggleExpandedHandler()}
                style={{ cursor: 'pointer', marginRight: '0.25rem' }}
              >
                {row.getIsExpanded() ? '👇' : '👉'}
              </button>
            ) : (
              <span style={{ marginRight: '0.25rem' }}>·</span>
            )}
            {String(getValue())}
          </div>
        ),
      }),
      columnHelper.accessor((row) => row.lastName, {
        id: 'lastName',
        size: 180,
        header: 'Last Name',
        meta: { filterVariant: 'text' },
      }),
      columnHelper.accessor('age', {
        id: 'age',
        size: 200,
        header: 'Age',
        meta: { filterVariant: 'range' },
        aggregationFn: 'median',
        aggregatedCell: ({ getValue }) =>
          Math.round(getValue<number>() * 100) / 100,
      }),
      columnHelper.accessor('visits', {
        id: 'visits',
        size: 200,
        header: 'Visits',
        meta: { filterVariant: 'range' },
        aggregationFn: 'sum',
        aggregatedCell: ({ getValue }) => getValue<number>().toLocaleString(),
      }),
      columnHelper.accessor('status', {
        id: 'status',
        size: 200,
        header: 'Status',
        sortFn: sortStatusFn,
        meta: { filterVariant: 'select' },
      }),
      columnHelper.accessor('progress', {
        id: 'progress',
        size: 200,
        header: 'Profile Progress',
        meta: { filterVariant: 'range' },
        aggregationFn: 'mean',
        cell: ({ getValue }) =>
          `${Math.round(getValue<number>() * 100) / 100}%`,
        aggregatedCell: ({ getValue }) =>
          `${Math.round(getValue<number>() * 100) / 100}%`,
      }),
    ])
  }, [])

  const [data, setData] = React.useState(() => makeData(1_000))
  const refreshData = () => setData(makeData(1_000))
  const nestedData = () => setData(makeData(100, 5, 3))
  const stress10k = () => setData(makeData(10_000))
  const stress100k = () => setData(makeData(100_000))

  const table = useTable(
    {
      key: 'kitchen-sink', // needed for devtools
      features: stockFeatures,
      rowModels: {
        expandedRowModel: createExpandedRowModel(),
        filteredRowModel: createFilteredRowModel({
          ...filterFns,
          fuzzy: fuzzyFilter,
        }),
        facetedRowModel: createFacetedRowModel(),
        facetedMinMaxValues: createFacetedMinMaxValues(),
        facetedUniqueValues: createFacetedUniqueValues(),
        groupedRowModel: createGroupedRowModel(aggregationFns),
        paginatedRowModel: createPaginatedRowModel(),
        sortedRowModel: createSortedRowModel(sortFns),
      },
      columns,
      data,
      getSubRows: (row) => row.subRows,
      globalFilterFn: 'fuzzy',
      columnResizeMode: 'onChange',
      defaultColumn: { minSize: 200, maxSize: 800 },
      initialState: {
        columnOrder: columns.map((c) => c.id!),
        columnPinning: { left: ['select'], right: [] },
        pagination: { pageIndex: 0, pageSize: 20 },
      },
      keepPinnedRows: true,
      debugTable: true,
    },
    (state) => state, // default selector
  )

  useTanStackTableDevtools(table)

  // memoized column-size css variables (column-resizing-performant pattern)
  const columnSizeVars = React.useMemo(() => {
    const headers = table.getFlatHeaders()
    const colSizes: Record<string, number> = {}
    for (let i = 0; i < headers.length; i++) {
      const header = headers[i]
      colSizes[`--header-${header.id}-size`] = header.getSize()
      colSizes[`--col-${header.column.id}-size`] = header.column.getSize()
    }
    return colSizes
  }, [table.state.columnResizing, table.state.columnSizing])

  // DnD column reordering
  const handleDragEnd = (event: DragEndEvent) => {
    const { active, over } = event
    if (over && active.id !== over.id) {
      table.setColumnOrder((prev) => {
        const oldIndex = prev.indexOf(active.id as string)
        const newIndex = prev.indexOf(over.id as string)
        return arrayMove(prev, oldIndex, newIndex)
      })
    }
  }

  const sensors = useSensors(
    useSensor(MouseSensor, {}),
    useSensor(TouchSensor, {}),
    useSensor(KeyboardSensor, {}),
  )

  const selectedCount = table.getSelectedRowModel().flatRows.length

  return (
    <DndContext
      collisionDetection={closestCenter}
      modifiers={[restrictToHorizontalAxis]}
      onDragEnd={handleDragEnd}
      sensors={sensors}
    >
      <div className="demo-root">
        <h1>Kitchen Sink — All Features</h1>

        {/* Toolbar */}
        <div className="toolbar">
          <div className="toolbar-row">
            <DebouncedInput
              value={(table.state.globalFilter ?? '') as string}
              onChange={(value) => table.setGlobalFilter(String(value))}
              className="global-filter-input"
              placeholder="Fuzzy search all columns..."
            />
          </div>
          <div className="toolbar-row">
            <button
              onClick={refreshData}
              className="demo-button demo-button-sm"
            >
              Flat 1k
            </button>
            <button onClick={nestedData} className="demo-button demo-button-sm">
              Nested 100×5×3
            </button>
            <button onClick={stress10k} className="demo-button demo-button-sm">
              Stress 10k (flat)
            </button>
            <button onClick={stress100k} className="demo-button demo-button-sm">
              Stress 100k (flat)
            </button>
            <button
              onClick={() => table.reset()}
              className="demo-button demo-button-sm"
            >
              Reset Table
            </button>
            <button
              onClick={() => rerender()}
              className="demo-button demo-button-sm"
            >
              Force Rerender
            </button>
            <span className="nowrap">
              {selectedCount.toLocaleString()} of{' '}
              {table.getCoreRowModel().flatRows.length.toLocaleString()}{' '}
              selected
            </span>
          </div>
          <details className="column-toggle-panel">
            <summary className="column-toggle-panel-header">
              Column visibility
            </summary>
            <div className="column-toggle-row">
              <label>
                <input
                  type="checkbox"
                  checked={table.getIsAllColumnsVisible()}
                  onChange={table.getToggleAllColumnsVisibilityHandler()}
                />{' '}
                Toggle All
              </label>
            </div>
            {table.getAllLeafColumns().map((column) => (
              <div key={column.id} className="column-toggle-row">
                <label>
                  <input
                    type="checkbox"
                    checked={column.getIsVisible()}
                    disabled={!column.getCanHide()}
                    onChange={column.getToggleVisibilityHandler()}
                  />{' '}
                  {column.id}
                </label>
              </div>
            ))}
          </details>
        </div>

        {/* Table */}
        <div className="table-container">
          <table style={{ ...columnSizeVars, width: table.getTotalSize() }}>
            <thead>
              {table.getHeaderGroups().map((headerGroup) => (
                <tr key={headerGroup.id}>
                  <SortableContext
                    items={table.state.columnOrder}
                    strategy={horizontalListSortingStrategy}
                  >
                    {headerGroup.headers.map((header) => (
                      <DraggableTableHeader
                        key={header.id}
                        header={header}
                        table={table}
                      />
                    ))}
                  </SortableContext>
                </tr>
              ))}
            </thead>
            <tbody>
              {table.getTopRows().map((row) => (
                <PinnedRow key={row.id} row={row} table={table} />
              ))}
              {table.getCenterRows().map((row) => (
                <tr key={row.id}>
                  {row.getVisibleCells().map((cell) => (
                    <SortableContext
                      key={cell.id}
                      items={table.state.columnOrder}
                      strategy={horizontalListSortingStrategy}
                    >
                      <DragAlongCell key={cell.id} cell={cell} table={table} />
                    </SortableContext>
                  ))}
                </tr>
              ))}
              {table.getBottomRows().map((row) => (
                <PinnedRow key={row.id} row={row} table={table} />
              ))}
            </tbody>
          </table>
        </div>

        {/* Pagination */}
        <div className="spacer-sm" />
        <div className="controls">
          <button
            className="demo-button demo-button-sm"
            onClick={() => table.setPageIndex(0)}
            disabled={!table.getCanPreviousPage()}
          >
            {'<<'}
          </button>
          <button
            className="demo-button demo-button-sm"
            onClick={() => table.previousPage()}
            disabled={!table.getCanPreviousPage()}
          >
            {'<'}
          </button>
          <button
            className="demo-button demo-button-sm"
            onClick={() => table.nextPage()}
            disabled={!table.getCanNextPage()}
          >
            {'>'}
          </button>
          <button
            className="demo-button demo-button-sm"
            onClick={() => table.setPageIndex(table.getPageCount() - 1)}
            disabled={!table.getCanNextPage()}
          >
            {'>>'}
          </button>
          <span className="inline-controls">
            <div>Page</div>
            <strong>
              {(table.state.pagination.pageIndex + 1).toLocaleString()} of{' '}
              {table.getPageCount().toLocaleString()}
            </strong>
          </span>
          <span className="inline-controls">
            | Go to page:
            <input
              type="number"
              min="1"
              max={table.getPageCount()}
              defaultValue={table.state.pagination.pageIndex + 1}
              onChange={(e) => {
                const page = e.target.value ? Number(e.target.value) - 1 : 0
                table.setPageIndex(page)
              }}
              className="page-size-input"
            />
          </span>
          <select
            value={table.state.pagination.pageSize}
            onChange={(e) => table.setPageSize(Number(e.target.value))}
          >
            {[10, 20, 30, 50, 100].map((pageSize) => (
              <option key={pageSize} value={pageSize}>
                Show {pageSize}
              </option>
            ))}
          </select>
        </div>
        <div className="spacer-sm" />
        <div className="nowrap">
          {table.getRowModel().rows.length.toLocaleString()} rows on this page (
          {table.getFilteredRowModel().rows.length.toLocaleString()} filtered of{' '}
          {table.getCoreRowModel().rows.length.toLocaleString()} total)
        </div>
        <div className="spacer-md" />
        <details>
          <summary>Table state (live)</summary>
          <pre className="state-dump">
            {JSON.stringify(table.state, null, 2)}
          </pre>
        </details>
      </div>
    </DndContext>
  )
}

const rootElement = document.getElementById('root')
if (!rootElement) throw new Error('Failed to find the root element')

ReactDOM.createRoot(rootElement).render(
  <React.StrictMode>
    <App />
    <TanStackDevtools plugins={[tableDevtoolsPlugin()]} />
  </React.StrictMode>,
)

Docs
Cloudflare
Railway
CodeRabbit
OpenRouter
SerpAPI
Netlify
Clerk
AG Grid
WorkOS
Electric
Sentry
Prisma
Unkey
Cloudflare
Railway
CodeRabbit
OpenRouter
SerpAPI
Netlify
Clerk
AG Grid
WorkOS
Electric
Sentry
Prisma
Unkey
Table API Reference
Column API Reference
Row API Reference
Cell API Reference
Header API Reference
Features API Reference
Static Functions API Reference

Vue Example: Kitchen Sink

<script setup lang="ts">
import { useTanStackTableDevtools } from '@tanstack/vue-table-devtools'
import { computed, ref } from 'vue'
import { faker } from '@faker-js/faker'
import {
  FlexRender,
  aggregationFns,
  createColumnHelper,
  createExpandedRowModel,
  createFacetedMinMaxValues,
  createFacetedRowModel,
  createFacetedUniqueValues,
  createFilteredRowModel,
  createGroupedRowModel,
  createPaginatedRowModel,
  createSortedRowModel,
  filterFns,
  sortFns,
  stockFeatures,
  useTable,
} from '@tanstack/vue-table'
import { compareItems, rankItem } from '@tanstack/match-sorter-utils'
import { makeData } from './makeData'
import type { CSSProperties } from 'vue'
import type { RankingInfo } from '@tanstack/match-sorter-utils'
import type { Person } from './makeData'
import type {
  Cell,
  CellData,
  Column,
  FilterFn,
  Header,
  Row,
  RowData,
  SortFn,
  TableFeatures,
} from '@tanstack/vue-table'

declare module '@tanstack/vue-table' {
  interface ColumnMeta<
    TFeatures extends TableFeatures,
    TData extends RowData,
    TValue extends CellData = CellData,
  > {
    filterVariant?: 'text' | 'range' | 'select'
  }
  interface FilterFns {
    fuzzy: FilterFn<typeof stockFeatures, Person>
  }
  interface FilterMeta {
    itemRank?: RankingInfo
  }
}

const fuzzyFilter: FilterFn<typeof stockFeatures, Person> = (
  row,
  columnId,
  value,
  addMeta,
) => {
  const itemRank = rankItem(row.getValue(columnId), value)
  addMeta?.({ itemRank })
  return itemRank.passed
}

const fuzzySort: SortFn<typeof stockFeatures, Person> = (
  rowA,
  rowB,
  columnId,
) => {
  let dir = 0
  if (rowA.columnFiltersMeta[columnId]) {
    dir = compareItems(
      rowA.columnFiltersMeta[columnId].itemRank!,
      rowB.columnFiltersMeta[columnId].itemRank!,
    )
  }
  return dir === 0 ? sortFns.alphanumeric(rowA, rowB, columnId) : dir
}

const sortStatusFn: SortFn<typeof stockFeatures, Person> = (rowA, rowB) => {
  const statusOrder = ['single', 'complicated', 'relationship']
  return (
    statusOrder.indexOf(rowA.original.status) -
    statusOrder.indexOf(rowB.original.status)
  )
}

const columnHelper = createColumnHelper<typeof stockFeatures, Person>()

const columns = ref(
  columnHelper.columns([
    columnHelper.display({
      id: 'select',
      size: 80,
      minSize: 80,
      maxSize: 80,
      enableSorting: false,
      enableGrouping: false,
      enableHiding: false,
      enableResizing: false,
      header: ({ table }) =>
        table.getIsAllPageRowsSelected()
          ? 'all'
          : table.getIsSomePageRowsSelected()
            ? 'some'
            : 'none',
      cell: ({ row }) => (row.getIsPinned() === 'top' ? 'Pinned' : 'Pin'),
    }),
    columnHelper.accessor('firstName', {
      id: 'firstName',
      size: 200,
      header: 'First Name',
      filterFn: 'fuzzy',
      sortFn: fuzzySort,
      meta: { filterVariant: 'text' },
      getGroupingValue: (row) => `${row.firstName} ${row.lastName}`,
    }),
    columnHelper.accessor((row) => row.lastName, {
      id: 'lastName',
      size: 180,
      header: 'Last Name',
      meta: { filterVariant: 'text' },
    }),
    columnHelper.accessor('age', {
      id: 'age',
      size: 200,
      header: 'Age',
      meta: { filterVariant: 'range' },
      aggregationFn: 'median',
      aggregatedCell: ({ getValue }) =>
        Math.round(getValue<number>() * 100) / 100,
    }),
    columnHelper.accessor('visits', {
      id: 'visits',
      size: 200,
      header: 'Visits',
      meta: { filterVariant: 'range' },
      aggregationFn: 'sum',
      aggregatedCell: ({ getValue }) => getValue<number>().toLocaleString(),
    }),
    columnHelper.accessor('status', {
      id: 'status',
      size: 200,
      header: 'Status',
      sortFn: sortStatusFn,
      meta: { filterVariant: 'select' },
    }),
    columnHelper.accessor('progress', {
      id: 'progress',
      size: 200,
      header: 'Profile Progress',
      meta: { filterVariant: 'range' },
      aggregationFn: 'mean',
      cell: ({ getValue }) => `${Math.round(getValue<number>() * 100) / 100}%`,
      aggregatedCell: ({ getValue }) =>
        `${Math.round(getValue<number>() * 100) / 100}%`,
    }),
  ]),
)

const data = ref(makeData(1_000))

const table = useTable({
  key: 'kitchen-sink', // needed for devtools
  features: stockFeatures,
  rowModels: {
    expandedRowModel: createExpandedRowModel(),
    filteredRowModel: createFilteredRowModel({
      ...filterFns,
      fuzzy: fuzzyFilter,
    }),
    facetedRowModel: createFacetedRowModel(),
    facetedMinMaxValues: createFacetedMinMaxValues(),
    facetedUniqueValues: createFacetedUniqueValues(),
    groupedRowModel: createGroupedRowModel(aggregationFns),
    paginatedRowModel: createPaginatedRowModel(),
    sortedRowModel: createSortedRowModel(sortFns),
  },
  data,
  get columns() {
    return columns.value
  },
  getSubRows: (row: Person) => row.subRows,
  globalFilterFn: 'fuzzy',
  columnResizeMode: 'onChange',
  defaultColumn: { minSize: 200, maxSize: 800 },
  initialState: {
    columnOrder: columns.value.map((c) => c.id!),
    columnPinning: { left: ['select'], right: [] },
    pagination: { pageIndex: 0, pageSize: 20 },
  },
  keepPinnedRows: true,
  debugTable: true,
})

useTanStackTableDevtools(table)

const columnSizeVars = computed(() => {
  void table.atoms.columnResizing.get()
  void table.atoms.columnSizing.get()
  const colSizes: Record<string, number> = {}
  for (const header of table.getFlatHeaders()) {
    colSizes[`--header-${header.id}-size`] = header.getSize()
    colSizes[`--col-${header.column.id}-size`] = header.column.getSize()
  }
  return colSizes
})

const debounceTimers = new Map<string, ReturnType<typeof setTimeout>>()

function debounceSet(key: string, setValue: () => void) {
  clearTimeout(debounceTimers.get(key))
  debounceTimers.set(
    key,
    setTimeout(() => {
      setValue()
      debounceTimers.delete(key)
    }, 300),
  )
}

function getCommonPinningStyles(
  column: Column<typeof stockFeatures, Person>,
): CSSProperties {
  const isPinned = column.getIsPinned()
  const isLastLeftPinnedColumn =
    isPinned === 'left' && column.getIsLastColumn('left')
  const isFirstRightPinnedColumn =
    isPinned === 'right' && column.getIsFirstColumn('right')

  return {
    boxShadow: isLastLeftPinnedColumn
      ? '-4px 0 4px -4px gray inset'
      : isFirstRightPinnedColumn
        ? '4px 0 4px -4px gray inset'
        : undefined,
    left: isPinned === 'left' ? `${column.getStart('left')}px` : undefined,
    right: isPinned === 'right' ? `${column.getAfter('right')}px` : undefined,
    opacity: isPinned ? 0.97 : 1,
    position: isPinned ? 'sticky' : 'relative',
    zIndex: isPinned ? 1 : 0,
  }
}

function headerStyle(
  header: Header<typeof stockFeatures, Person, unknown>,
): CSSProperties {
  return {
    ...getCommonPinningStyles(header.column),
    whiteSpace: 'nowrap',
    width: `calc(var(--header-${header.id}-size) * 1px)`,
  }
}

function cellStyle(cell: Cell<typeof stockFeatures, Person, unknown>) {
  return {
    ...getCommonPinningStyles(cell.column),
    width: `calc(var(--col-${cell.column.id}-size) * 1px)`,
  }
}

function cellClass(cell: Cell<typeof stockFeatures, Person, unknown>) {
  const groupingActive = table.atoms.grouping.get().length > 0
  const hasAggregation = !!cell.column.columnDef.aggregationFn
  return !groupingActive
    ? undefined
    : cell.getIsGrouped()
      ? 'cell-grouped'
      : hasAggregation && cell.getIsAggregated()
        ? 'cell-aggregated'
        : cell.getIsPlaceholder()
          ? 'cell-placeholder'
          : undefined
}

function rowStyle(row: Row<typeof stockFeatures, Person>): CSSProperties {
  const bottomRows = table.getBottomRows()
  return {
    position: 'sticky',
    top:
      row.getIsPinned() === 'top'
        ? `${row.getPinnedIndex() * 32 + 48}px`
        : undefined,
    bottom:
      row.getIsPinned() === 'bottom'
        ? `${(bottomRows.length - 1 - row.getPinnedIndex()) * 32}px`
        : undefined,
    zIndex: 1,
  }
}

function sortedUniqueValues(column: Column<typeof stockFeatures, Person>) {
  if (column.columnDef.meta?.filterVariant === 'range') return []
  return Array.from(column.getFacetedUniqueValues().keys())
    .sort()
    .slice(0, 5000)
}

function updateRangeFilter(
  column: Column<typeof stockFeatures, Person>,
  index: 0 | 1,
  value: string,
) {
  column.setFilterValue((old: [number, number] | undefined) => {
    return index === 0 ? [value, old?.[1]] : [old?.[0], value]
  })
}

function refreshData() {
  data.value = makeData(1_000)
}

function nestedData() {
  data.value = makeData(100, 5, 3)
}

function stress10k() {
  data.value = makeData(10_000)
}

function stress100k() {
  data.value = makeData(100_000)
}

function shuffleColumns() {
  table.setColumnOrder(
    faker.helpers.shuffle(table.getAllLeafColumns().map((d) => d.id)),
  )
}
</script>

<template>
  <div class="demo-root">
    <h1>Kitchen Sink - All Features</h1>
    <div class="toolbar">
      <div class="toolbar-row">
        <input
          class="global-filter-input"
          placeholder="Fuzzy search all columns..."
          :value="table.atoms.globalFilter.get() ?? ''"
          @input="
            (event) =>
              debounceSet('global', () =>
                table.setGlobalFilter((event.target as HTMLInputElement).value),
              )
          "
        />
      </div>
      <div class="toolbar-row">
        <button @click="refreshData" class="demo-button demo-button-sm">
          Flat 1k
        </button>
        <button @click="nestedData" class="demo-button demo-button-sm">
          Nested 100x5x3
        </button>
        <button @click="stress10k" class="demo-button demo-button-sm">
          Stress 10k (flat)
        </button>
        <button @click="stress100k" class="demo-button demo-button-sm">
          Stress 100k (flat)
        </button>
        <button @click="table.reset()" class="demo-button demo-button-sm">
          Reset Table
        </button>
        <button @click="shuffleColumns" class="demo-button demo-button-sm">
          Shuffle Columns
        </button>
        <span class="nowrap">
          {{ table.getSelectedRowModel().flatRows.length.toLocaleString() }} of
          {{ table.getCoreRowModel().flatRows.length.toLocaleString() }}
          selected
        </span>
      </div>
      <details class="column-toggle-panel">
        <summary class="column-toggle-panel-header">Column visibility</summary>
        <div class="column-toggle-row">
          <label>
            <input
              type="checkbox"
              :checked="table.getIsAllColumnsVisible()"
              @change="table.getToggleAllColumnsVisibilityHandler()?.($event)"
            />
            Toggle All
          </label>
        </div>
        <div
          v-for="column in table.getAllLeafColumns()"
          :key="column.id"
          class="column-toggle-row"
        >
          <label>
            <input
              type="checkbox"
              :checked="column.getIsVisible()"
              :disabled="!column.getCanHide()"
              @change="column.getToggleVisibilityHandler()?.($event)"
            />
            {{ column.id }}
          </label>
        </div>
      </details>
    </div>

    <div class="table-container">
      <table :style="{ ...columnSizeVars, width: table.getTotalSize() + 'px' }">
        <thead>
          <tr
            v-for="headerGroup in table.getHeaderGroups()"
            :key="headerGroup.id"
          >
            <th
              v-for="header in headerGroup.headers"
              :key="header.id"
              :colspan="header.colSpan"
              :style="headerStyle(header)"
            >
              <template v-if="!header.isPlaceholder">
                <div class="header-row">
                  <div style="flex: 1; min-width: 0">
                    <div class="header-controls">
                      <span
                        v-if="header.column.getCanPin()"
                        class="pin-actions"
                      >
                        <button
                          v-if="header.column.getIsPinned() !== 'left'"
                          class="pin-button"
                          @click="header.column.pin('left')"
                        >
                          &lt;
                        </button>
                        <button
                          v-if="header.column.getIsPinned()"
                          class="pin-button"
                          @click="header.column.pin(false)"
                        >
                          x
                        </button>
                        <button
                          v-if="header.column.getIsPinned() !== 'right'"
                          class="pin-button"
                          @click="header.column.pin('right')"
                        >
                          &gt;
                        </button>
                      </span>
                      <button
                        v-if="header.column.getCanGroup()"
                        class="pin-button"
                        @click="header.column.getToggleGroupingHandler()?.()"
                      >
                        {{
                          header.column.getIsGrouped()
                            ? `Stop (${header.column.getGroupedIndex()})`
                            : 'Group'
                        }}
                      </button>
                    </div>
                    <template v-if="header.column.id === 'select'">
                      <input
                        type="checkbox"
                        :checked="table.getIsAllPageRowsSelected()"
                        :indeterminate="table.getIsSomePageRowsSelected()"
                        @change="
                          table.getToggleAllPageRowsSelectedHandler()?.($event)
                        "
                      />
                    </template>
                    <span
                      v-else-if="header.column.getCanSort()"
                      class="sortable-header"
                      @click="header.column.getToggleSortingHandler()?.($event)"
                    >
                      <FlexRender :header="header" />
                      {{
                        header.column.getIsSorted() === 'asc'
                          ? ' â–²'
                          : header.column.getIsSorted() === 'desc'
                            ? ' â–¼'
                            : ''
                      }}
                    </span>
                    <FlexRender v-else :header="header" />
                    <div v-if="header.column.getCanFilter()">
                      <div
                        v-if="
                          header.column.columnDef.meta?.filterVariant ===
                          'range'
                        "
                        class="filter-row"
                      >
                        <input
                          type="number"
                          class="filter-input"
                          :min="
                            header.column.getFacetedMinMaxValues()?.[0] ?? ''
                          "
                          :max="
                            header.column.getFacetedMinMaxValues()?.[1] ?? ''
                          "
                          :value="
                            (
                              header.column.getFilterValue() as
                                | [number, number]
                                | undefined
                            )?.[0] ?? ''
                          "
                          :placeholder="`Min${header.column.getFacetedMinMaxValues()?.[0] !== undefined ? ` (${header.column.getFacetedMinMaxValues()?.[0]})` : ''}`"
                          @input="
                            (event) =>
                              debounceSet(header.column.id + '-min', () =>
                                updateRangeFilter(
                                  header.column,
                                  0,
                                  (event.target as HTMLInputElement).value,
                                ),
                              )
                          "
                        />
                        <input
                          type="number"
                          class="filter-input"
                          :min="
                            header.column.getFacetedMinMaxValues()?.[0] ?? ''
                          "
                          :max="
                            header.column.getFacetedMinMaxValues()?.[1] ?? ''
                          "
                          :value="
                            (
                              header.column.getFilterValue() as
                                | [number, number]
                                | undefined
                            )?.[1] ?? ''
                          "
                          :placeholder="`Max${header.column.getFacetedMinMaxValues()?.[1] !== undefined ? ` (${header.column.getFacetedMinMaxValues()?.[1]})` : ''}`"
                          @input="
                            (event) =>
                              debounceSet(header.column.id + '-max', () =>
                                updateRangeFilter(
                                  header.column,
                                  1,
                                  (event.target as HTMLInputElement).value,
                                ),
                              )
                          "
                        />
                      </div>
                      <select
                        v-else-if="
                          header.column.columnDef.meta?.filterVariant ===
                          'select'
                        "
                        class="filter-select"
                        :value="
                          (header.column.getFilterValue() ?? '').toString()
                        "
                        @change="
                          header.column.setFilterValue(
                            ($event.target as HTMLSelectElement).value,
                          )
                        "
                      >
                        <option value="">All</option>
                        <option
                          v-for="value in sortedUniqueValues(header.column)"
                          :key="String(value)"
                          :value="String(value)"
                        >
                          {{ String(value) }}
                        </option>
                      </select>
                      <template v-else>
                        <datalist :id="header.column.id + 'list'">
                          <option
                            v-for="value in sortedUniqueValues(header.column)"
                            :key="String(value)"
                            :value="String(value)"
                          />
                        </datalist>
                        <input
                          type="text"
                          class="filter-select"
                          :list="header.column.id + 'list'"
                          :value="
                            (header.column.getFilterValue() ?? '') as string
                          "
                          :placeholder="`Search (${header.column.getFacetedUniqueValues().size})`"
                          @input="
                            (event) =>
                              debounceSet(header.column.id, () =>
                                header.column.setFilterValue(
                                  (event.target as HTMLInputElement).value,
                                ),
                              )
                          "
                        />
                      </template>
                    </div>
                  </div>
                </div>
                <div
                  v-if="header.column.getCanResize()"
                  :class="`resizer ${header.column.getIsResizing() ? 'isResizing' : ''}`"
                  @dblclick="header.column.resetSize()"
                  @mousedown="header.getResizeHandler()($event)"
                  @touchstart="header.getResizeHandler()($event)"
                />
              </template>
            </th>
          </tr>
        </thead>
        <tbody>
          <tr
            v-for="row in table.getTopRows()"
            :key="row.id"
            class="pinned-row"
            :style="rowStyle(row)"
          >
            <td
              v-for="cell in row.getVisibleCells()"
              :key="cell.id"
              :style="cellStyle(cell)"
              :class="cellClass(cell)"
            >
              <FlexRender :cell="cell" />
            </td>
          </tr>
          <tr v-for="row in table.getCenterRows()" :key="row.id">
            <td
              v-for="cell in row.getVisibleCells()"
              :key="cell.id"
              :style="cellStyle(cell)"
              :class="cellClass(cell)"
            >
              <template v-if="cell.column.id === 'select'">
                <div class="column-toggle-row">
                  <input
                    type="checkbox"
                    :checked="cell.row.getIsSelected()"
                    :disabled="!cell.row.getCanSelect()"
                    :indeterminate="cell.row.getIsSomeSelected()"
                    @change="cell.row.getToggleSelectedHandler()?.($event)"
                  />
                  <button
                    class="pin-button"
                    @click="
                      cell.row.pin(
                        cell.row.getIsPinned() === 'top' ? false : 'top',
                      )
                    "
                  >
                    {{ cell.row.getIsPinned() === 'top' ? 'Pinned' : 'Pin' }}
                  </button>
                </div>
              </template>
              <template v-else-if="cell.column.id === 'firstName'">
                <div :style="{ paddingLeft: `${cell.row.depth * 1.5}rem` }">
                  <button
                    v-if="cell.row.getCanExpand()"
                    @click="cell.row.getToggleExpandedHandler()?.()"
                    style="cursor: pointer; margin-right: 0.25rem"
                  >
                    {{ cell.row.getIsExpanded() ? 'v' : '>' }}
                  </button>
                  <span v-else style="margin-right: 0.25rem">-</span>
                  <FlexRender :cell="cell" />
                </div>
              </template>
              <template v-else-if="cell.getIsGrouped()">
                <button
                  @click="cell.row.getToggleExpandedHandler()?.()"
                  :style="{
                    cursor: cell.row.getCanExpand() ? 'pointer' : 'normal',
                  }"
                >
                  {{ cell.row.getIsExpanded() ? 'v' : '>' }}
                  <FlexRender :cell="cell" />
                  ({{ cell.row.subRows.length.toLocaleString() }})
                </button>
              </template>
              <FlexRender v-else :cell="cell" />
            </td>
          </tr>
          <tr
            v-for="row in table.getBottomRows()"
            :key="row.id"
            class="pinned-row"
            :style="rowStyle(row)"
          >
            <td
              v-for="cell in row.getVisibleCells()"
              :key="cell.id"
              :style="cellStyle(cell)"
              :class="cellClass(cell)"
            >
              <FlexRender :cell="cell" />
            </td>
          </tr>
        </tbody>
      </table>
    </div>

    <div class="spacer-sm" />
    <div class="controls">
      <button
        class="demo-button demo-button-sm"
        @click="table.setPageIndex(0)"
        :disabled="!table.getCanPreviousPage()"
      >
        &lt;&lt;
      </button>
      <button
        class="demo-button demo-button-sm"
        @click="table.previousPage()"
        :disabled="!table.getCanPreviousPage()"
      >
        &lt;
      </button>
      <button
        class="demo-button demo-button-sm"
        @click="table.nextPage()"
        :disabled="!table.getCanNextPage()"
      >
        &gt;
      </button>
      <button
        class="demo-button demo-button-sm"
        @click="table.setPageIndex(table.getPageCount() - 1)"
        :disabled="!table.getCanNextPage()"
      >
        &gt;&gt;
      </button>
      <span class="inline-controls">
        <div>Page</div>
        <strong>
          {{ (table.atoms.pagination.get().pageIndex + 1).toLocaleString() }} of
          {{ table.getPageCount().toLocaleString() }}
        </strong>
      </span>
      <span class="inline-controls">
        | Go to page:
        <input
          type="number"
          min="1"
          :max="table.getPageCount()"
          :value="table.atoms.pagination.get().pageIndex + 1"
          @input="
            table.setPageIndex(
              ($event.target as HTMLInputElement).value
                ? Number(($event.target as HTMLInputElement).value) - 1
                : 0,
            )
          "
          class="page-size-input"
        />
      </span>
      <select
        :value="table.atoms.pagination.get().pageSize"
        @change="
          table.setPageSize(Number(($event.target as HTMLSelectElement).value))
        "
      >
        <option
          v-for="pageSize in [10, 20, 30, 50, 100]"
          :key="pageSize"
          :value="pageSize"
        >
          Show {{ pageSize }}
        </option>
      </select>
    </div>
    <div class="spacer-sm" />
    <div class="nowrap">
      {{ table.getRowModel().rows.length.toLocaleString() }} rows on this page
      ({{ table.getFilteredRowModel().rows.length.toLocaleString() }} filtered
      of {{ table.getCoreRowModel().rows.length.toLocaleString() }} total)
    </div>
    <div class="spacer-md" />
    <details>
      <summary>Table state (live)</summary>
      <pre class="state-dump">{{
        JSON.stringify(table.store.get(), null, 2)
      }}</pre>
    </details>
  </div>
</template>
<script setup lang="ts">
import { useTanStackTableDevtools } from '@tanstack/vue-table-devtools'
import { computed, ref } from 'vue'
import { faker } from '@faker-js/faker'
import {
  FlexRender,
  aggregationFns,
  createColumnHelper,
  createExpandedRowModel,
  createFacetedMinMaxValues,
  createFacetedRowModel,
  createFacetedUniqueValues,
  createFilteredRowModel,
  createGroupedRowModel,
  createPaginatedRowModel,
  createSortedRowModel,
  filterFns,
  sortFns,
  stockFeatures,
  useTable,
} from '@tanstack/vue-table'
import { compareItems, rankItem } from '@tanstack/match-sorter-utils'
import { makeData } from './makeData'
import type { CSSProperties } from 'vue'
import type { RankingInfo } from '@tanstack/match-sorter-utils'
import type { Person } from './makeData'
import type {
  Cell,
  CellData,
  Column,
  FilterFn,
  Header,
  Row,
  RowData,
  SortFn,
  TableFeatures,
} from '@tanstack/vue-table'

declare module '@tanstack/vue-table' {
  interface ColumnMeta<
    TFeatures extends TableFeatures,
    TData extends RowData,
    TValue extends CellData = CellData,
  > {
    filterVariant?: 'text' | 'range' | 'select'
  }
  interface FilterFns {
    fuzzy: FilterFn<typeof stockFeatures, Person>
  }
  interface FilterMeta {
    itemRank?: RankingInfo
  }
}

const fuzzyFilter: FilterFn<typeof stockFeatures, Person> = (
  row,
  columnId,
  value,
  addMeta,
) => {
  const itemRank = rankItem(row.getValue(columnId), value)
  addMeta?.({ itemRank })
  return itemRank.passed
}

const fuzzySort: SortFn<typeof stockFeatures, Person> = (
  rowA,
  rowB,
  columnId,
) => {
  let dir = 0
  if (rowA.columnFiltersMeta[columnId]) {
    dir = compareItems(
      rowA.columnFiltersMeta[columnId].itemRank!,
      rowB.columnFiltersMeta[columnId].itemRank!,
    )
  }
  return dir === 0 ? sortFns.alphanumeric(rowA, rowB, columnId) : dir
}

const sortStatusFn: SortFn<typeof stockFeatures, Person> = (rowA, rowB) => {
  const statusOrder = ['single', 'complicated', 'relationship']
  return (
    statusOrder.indexOf(rowA.original.status) -
    statusOrder.indexOf(rowB.original.status)
  )
}

const columnHelper = createColumnHelper<typeof stockFeatures, Person>()

const columns = ref(
  columnHelper.columns([
    columnHelper.display({
      id: 'select',
      size: 80,
      minSize: 80,
      maxSize: 80,
      enableSorting: false,
      enableGrouping: false,
      enableHiding: false,
      enableResizing: false,
      header: ({ table }) =>
        table.getIsAllPageRowsSelected()
          ? 'all'
          : table.getIsSomePageRowsSelected()
            ? 'some'
            : 'none',
      cell: ({ row }) => (row.getIsPinned() === 'top' ? 'Pinned' : 'Pin'),
    }),
    columnHelper.accessor('firstName', {
      id: 'firstName',
      size: 200,
      header: 'First Name',
      filterFn: 'fuzzy',
      sortFn: fuzzySort,
      meta: { filterVariant: 'text' },
      getGroupingValue: (row) => `${row.firstName} ${row.lastName}`,
    }),
    columnHelper.accessor((row) => row.lastName, {
      id: 'lastName',
      size: 180,
      header: 'Last Name',
      meta: { filterVariant: 'text' },
    }),
    columnHelper.accessor('age', {
      id: 'age',
      size: 200,
      header: 'Age',
      meta: { filterVariant: 'range' },
      aggregationFn: 'median',
      aggregatedCell: ({ getValue }) =>
        Math.round(getValue<number>() * 100) / 100,
    }),
    columnHelper.accessor('visits', {
      id: 'visits',
      size: 200,
      header: 'Visits',
      meta: { filterVariant: 'range' },
      aggregationFn: 'sum',
      aggregatedCell: ({ getValue }) => getValue<number>().toLocaleString(),
    }),
    columnHelper.accessor('status', {
      id: 'status',
      size: 200,
      header: 'Status',
      sortFn: sortStatusFn,
      meta: { filterVariant: 'select' },
    }),
    columnHelper.accessor('progress', {
      id: 'progress',
      size: 200,
      header: 'Profile Progress',
      meta: { filterVariant: 'range' },
      aggregationFn: 'mean',
      cell: ({ getValue }) => `${Math.round(getValue<number>() * 100) / 100}%`,
      aggregatedCell: ({ getValue }) =>
        `${Math.round(getValue<number>() * 100) / 100}%`,
    }),
  ]),
)

const data = ref(makeData(1_000))

const table = useTable({
  key: 'kitchen-sink', // needed for devtools
  features: stockFeatures,
  rowModels: {
    expandedRowModel: createExpandedRowModel(),
    filteredRowModel: createFilteredRowModel({
      ...filterFns,
      fuzzy: fuzzyFilter,
    }),
    facetedRowModel: createFacetedRowModel(),
    facetedMinMaxValues: createFacetedMinMaxValues(),
    facetedUniqueValues: createFacetedUniqueValues(),
    groupedRowModel: createGroupedRowModel(aggregationFns),
    paginatedRowModel: createPaginatedRowModel(),
    sortedRowModel: createSortedRowModel(sortFns),
  },
  data,
  get columns() {
    return columns.value
  },
  getSubRows: (row: Person) => row.subRows,
  globalFilterFn: 'fuzzy',
  columnResizeMode: 'onChange',
  defaultColumn: { minSize: 200, maxSize: 800 },
  initialState: {
    columnOrder: columns.value.map((c) => c.id!),
    columnPinning: { left: ['select'], right: [] },
    pagination: { pageIndex: 0, pageSize: 20 },
  },
  keepPinnedRows: true,
  debugTable: true,
})

useTanStackTableDevtools(table)

const columnSizeVars = computed(() => {
  void table.atoms.columnResizing.get()
  void table.atoms.columnSizing.get()
  const colSizes: Record<string, number> = {}
  for (const header of table.getFlatHeaders()) {
    colSizes[`--header-${header.id}-size`] = header.getSize()
    colSizes[`--col-${header.column.id}-size`] = header.column.getSize()
  }
  return colSizes
})

const debounceTimers = new Map<string, ReturnType<typeof setTimeout>>()

function debounceSet(key: string, setValue: () => void) {
  clearTimeout(debounceTimers.get(key))
  debounceTimers.set(
    key,
    setTimeout(() => {
      setValue()
      debounceTimers.delete(key)
    }, 300),
  )
}

function getCommonPinningStyles(
  column: Column<typeof stockFeatures, Person>,
): CSSProperties {
  const isPinned = column.getIsPinned()
  const isLastLeftPinnedColumn =
    isPinned === 'left' && column.getIsLastColumn('left')
  const isFirstRightPinnedColumn =
    isPinned === 'right' && column.getIsFirstColumn('right')

  return {
    boxShadow: isLastLeftPinnedColumn
      ? '-4px 0 4px -4px gray inset'
      : isFirstRightPinnedColumn
        ? '4px 0 4px -4px gray inset'
        : undefined,
    left: isPinned === 'left' ? `${column.getStart('left')}px` : undefined,
    right: isPinned === 'right' ? `${column.getAfter('right')}px` : undefined,
    opacity: isPinned ? 0.97 : 1,
    position: isPinned ? 'sticky' : 'relative',
    zIndex: isPinned ? 1 : 0,
  }
}

function headerStyle(
  header: Header<typeof stockFeatures, Person, unknown>,
): CSSProperties {
  return {
    ...getCommonPinningStyles(header.column),
    whiteSpace: 'nowrap',
    width: `calc(var(--header-${header.id}-size) * 1px)`,
  }
}

function cellStyle(cell: Cell<typeof stockFeatures, Person, unknown>) {
  return {
    ...getCommonPinningStyles(cell.column),
    width: `calc(var(--col-${cell.column.id}-size) * 1px)`,
  }
}

function cellClass(cell: Cell<typeof stockFeatures, Person, unknown>) {
  const groupingActive = table.atoms.grouping.get().length > 0
  const hasAggregation = !!cell.column.columnDef.aggregationFn
  return !groupingActive
    ? undefined
    : cell.getIsGrouped()
      ? 'cell-grouped'
      : hasAggregation && cell.getIsAggregated()
        ? 'cell-aggregated'
        : cell.getIsPlaceholder()
          ? 'cell-placeholder'
          : undefined
}

function rowStyle(row: Row<typeof stockFeatures, Person>): CSSProperties {
  const bottomRows = table.getBottomRows()
  return {
    position: 'sticky',
    top:
      row.getIsPinned() === 'top'
        ? `${row.getPinnedIndex() * 32 + 48}px`
        : undefined,
    bottom:
      row.getIsPinned() === 'bottom'
        ? `${(bottomRows.length - 1 - row.getPinnedIndex()) * 32}px`
        : undefined,
    zIndex: 1,
  }
}

function sortedUniqueValues(column: Column<typeof stockFeatures, Person>) {
  if (column.columnDef.meta?.filterVariant === 'range') return []
  return Array.from(column.getFacetedUniqueValues().keys())
    .sort()
    .slice(0, 5000)
}

function updateRangeFilter(
  column: Column<typeof stockFeatures, Person>,
  index: 0 | 1,
  value: string,
) {
  column.setFilterValue((old: [number, number] | undefined) => {
    return index === 0 ? [value, old?.[1]] : [old?.[0], value]
  })
}

function refreshData() {
  data.value = makeData(1_000)
}

function nestedData() {
  data.value = makeData(100, 5, 3)
}

function stress10k() {
  data.value = makeData(10_000)
}

function stress100k() {
  data.value = makeData(100_000)
}

function shuffleColumns() {
  table.setColumnOrder(
    faker.helpers.shuffle(table.getAllLeafColumns().map((d) => d.id)),
  )
}
</script>

<template>
  <div class="demo-root">
    <h1>Kitchen Sink - All Features</h1>
    <div class="toolbar">
      <div class="toolbar-row">
        <input
          class="global-filter-input"
          placeholder="Fuzzy search all columns..."
          :value="table.atoms.globalFilter.get() ?? ''"
          @input="
            (event) =>
              debounceSet('global', () =>
                table.setGlobalFilter((event.target as HTMLInputElement).value),
              )
          "
        />
      </div>
      <div class="toolbar-row">
        <button @click="refreshData" class="demo-button demo-button-sm">
          Flat 1k
        </button>
        <button @click="nestedData" class="demo-button demo-button-sm">
          Nested 100x5x3
        </button>
        <button @click="stress10k" class="demo-button demo-button-sm">
          Stress 10k (flat)
        </button>
        <button @click="stress100k" class="demo-button demo-button-sm">
          Stress 100k (flat)
        </button>
        <button @click="table.reset()" class="demo-button demo-button-sm">
          Reset Table
        </button>
        <button @click="shuffleColumns" class="demo-button demo-button-sm">
          Shuffle Columns
        </button>
        <span class="nowrap">
          {{ table.getSelectedRowModel().flatRows.length.toLocaleString() }} of
          {{ table.getCoreRowModel().flatRows.length.toLocaleString() }}
          selected
        </span>
      </div>
      <details class="column-toggle-panel">
        <summary class="column-toggle-panel-header">Column visibility</summary>
        <div class="column-toggle-row">
          <label>
            <input
              type="checkbox"
              :checked="table.getIsAllColumnsVisible()"
              @change="table.getToggleAllColumnsVisibilityHandler()?.($event)"
            />
            Toggle All
          </label>
        </div>
        <div
          v-for="column in table.getAllLeafColumns()"
          :key="column.id"
          class="column-toggle-row"
        >
          <label>
            <input
              type="checkbox"
              :checked="column.getIsVisible()"
              :disabled="!column.getCanHide()"
              @change="column.getToggleVisibilityHandler()?.($event)"
            />
            {{ column.id }}
          </label>
        </div>
      </details>
    </div>

    <div class="table-container">
      <table :style="{ ...columnSizeVars, width: table.getTotalSize() + 'px' }">
        <thead>
          <tr
            v-for="headerGroup in table.getHeaderGroups()"
            :key="headerGroup.id"
          >
            <th
              v-for="header in headerGroup.headers"
              :key="header.id"
              :colspan="header.colSpan"
              :style="headerStyle(header)"
            >
              <template v-if="!header.isPlaceholder">
                <div class="header-row">
                  <div style="flex: 1; min-width: 0">
                    <div class="header-controls">
                      <span
                        v-if="header.column.getCanPin()"
                        class="pin-actions"
                      >
                        <button
                          v-if="header.column.getIsPinned() !== 'left'"
                          class="pin-button"
                          @click="header.column.pin('left')"
                        >
                          &lt;
                        </button>
                        <button
                          v-if="header.column.getIsPinned()"
                          class="pin-button"
                          @click="header.column.pin(false)"
                        >
                          x
                        </button>
                        <button
                          v-if="header.column.getIsPinned() !== 'right'"
                          class="pin-button"
                          @click="header.column.pin('right')"
                        >
                          &gt;
                        </button>
                      </span>
                      <button
                        v-if="header.column.getCanGroup()"
                        class="pin-button"
                        @click="header.column.getToggleGroupingHandler()?.()"
                      >
                        {{
                          header.column.getIsGrouped()
                            ? `Stop (${header.column.getGroupedIndex()})`
                            : 'Group'
                        }}
                      </button>
                    </div>
                    <template v-if="header.column.id === 'select'">
                      <input
                        type="checkbox"
                        :checked="table.getIsAllPageRowsSelected()"
                        :indeterminate="table.getIsSomePageRowsSelected()"
                        @change="
                          table.getToggleAllPageRowsSelectedHandler()?.($event)
                        "
                      />
                    </template>
                    <span
                      v-else-if="header.column.getCanSort()"
                      class="sortable-header"
                      @click="header.column.getToggleSortingHandler()?.($event)"
                    >
                      <FlexRender :header="header" />
                      {{
                        header.column.getIsSorted() === 'asc'
                          ? ' â–²'
                          : header.column.getIsSorted() === 'desc'
                            ? ' â–¼'
                            : ''
                      }}
                    </span>
                    <FlexRender v-else :header="header" />
                    <div v-if="header.column.getCanFilter()">
                      <div
                        v-if="
                          header.column.columnDef.meta?.filterVariant ===
                          'range'
                        "
                        class="filter-row"
                      >
                        <input
                          type="number"
                          class="filter-input"
                          :min="
                            header.column.getFacetedMinMaxValues()?.[0] ?? ''
                          "
                          :max="
                            header.column.getFacetedMinMaxValues()?.[1] ?? ''
                          "
                          :value="
                            (
                              header.column.getFilterValue() as
                                | [number, number]
                                | undefined
                            )?.[0] ?? ''
                          "
                          :placeholder="`Min${header.column.getFacetedMinMaxValues()?.[0] !== undefined ? ` (${header.column.getFacetedMinMaxValues()?.[0]})` : ''}`"
                          @input="
                            (event) =>
                              debounceSet(header.column.id + '-min', () =>
                                updateRangeFilter(
                                  header.column,
                                  0,
                                  (event.target as HTMLInputElement).value,
                                ),
                              )
                          "
                        />
                        <input
                          type="number"
                          class="filter-input"
                          :min="
                            header.column.getFacetedMinMaxValues()?.[0] ?? ''
                          "
                          :max="
                            header.column.getFacetedMinMaxValues()?.[1] ?? ''
                          "
                          :value="
                            (
                              header.column.getFilterValue() as
                                | [number, number]
                                | undefined
                            )?.[1] ?? ''
                          "
                          :placeholder="`Max${header.column.getFacetedMinMaxValues()?.[1] !== undefined ? ` (${header.column.getFacetedMinMaxValues()?.[1]})` : ''}`"
                          @input="
                            (event) =>
                              debounceSet(header.column.id + '-max', () =>
                                updateRangeFilter(
                                  header.column,
                                  1,
                                  (event.target as HTMLInputElement).value,
                                ),
                              )
                          "
                        />
                      </div>
                      <select
                        v-else-if="
                          header.column.columnDef.meta?.filterVariant ===
                          'select'
                        "
                        class="filter-select"
                        :value="
                          (header.column.getFilterValue() ?? '').toString()
                        "
                        @change="
                          header.column.setFilterValue(
                            ($event.target as HTMLSelectElement).value,
                          )
                        "
                      >
                        <option value="">All</option>
                        <option
                          v-for="value in sortedUniqueValues(header.column)"
                          :key="String(value)"
                          :value="String(value)"
                        >
                          {{ String(value) }}
                        </option>
                      </select>
                      <template v-else>
                        <datalist :id="header.column.id + 'list'">
                          <option
                            v-for="value in sortedUniqueValues(header.column)"
                            :key="String(value)"
                            :value="String(value)"
                          />
                        </datalist>
                        <input
                          type="text"
                          class="filter-select"
                          :list="header.column.id + 'list'"
                          :value="
                            (header.column.getFilterValue() ?? '') as string
                          "
                          :placeholder="`Search (${header.column.getFacetedUniqueValues().size})`"
                          @input="
                            (event) =>
                              debounceSet(header.column.id, () =>
                                header.column.setFilterValue(
                                  (event.target as HTMLInputElement).value,
                                ),
                              )
                          "
                        />
                      </template>
                    </div>
                  </div>
                </div>
                <div
                  v-if="header.column.getCanResize()"
                  :class="`resizer ${header.column.getIsResizing() ? 'isResizing' : ''}`"
                  @dblclick="header.column.resetSize()"
                  @mousedown="header.getResizeHandler()($event)"
                  @touchstart="header.getResizeHandler()($event)"
                />
              </template>
            </th>
          </tr>
        </thead>
        <tbody>
          <tr
            v-for="row in table.getTopRows()"
            :key="row.id"
            class="pinned-row"
            :style="rowStyle(row)"
          >
            <td
              v-for="cell in row.getVisibleCells()"
              :key="cell.id"
              :style="cellStyle(cell)"
              :class="cellClass(cell)"
            >
              <FlexRender :cell="cell" />
            </td>
          </tr>
          <tr v-for="row in table.getCenterRows()" :key="row.id">
            <td
              v-for="cell in row.getVisibleCells()"
              :key="cell.id"
              :style="cellStyle(cell)"
              :class="cellClass(cell)"
            >
              <template v-if="cell.column.id === 'select'">
                <div class="column-toggle-row">
                  <input
                    type="checkbox"
                    :checked="cell.row.getIsSelected()"
                    :disabled="!cell.row.getCanSelect()"
                    :indeterminate="cell.row.getIsSomeSelected()"
                    @change="cell.row.getToggleSelectedHandler()?.($event)"
                  />
                  <button
                    class="pin-button"
                    @click="
                      cell.row.pin(
                        cell.row.getIsPinned() === 'top' ? false : 'top',
                      )
                    "
                  >
                    {{ cell.row.getIsPinned() === 'top' ? 'Pinned' : 'Pin' }}
                  </button>
                </div>
              </template>
              <template v-else-if="cell.column.id === 'firstName'">
                <div :style="{ paddingLeft: `${cell.row.depth * 1.5}rem` }">
                  <button
                    v-if="cell.row.getCanExpand()"
                    @click="cell.row.getToggleExpandedHandler()?.()"
                    style="cursor: pointer; margin-right: 0.25rem"
                  >
                    {{ cell.row.getIsExpanded() ? 'v' : '>' }}
                  </button>
                  <span v-else style="margin-right: 0.25rem">-</span>
                  <FlexRender :cell="cell" />
                </div>
              </template>
              <template v-else-if="cell.getIsGrouped()">
                <button
                  @click="cell.row.getToggleExpandedHandler()?.()"
                  :style="{
                    cursor: cell.row.getCanExpand() ? 'pointer' : 'normal',
                  }"
                >
                  {{ cell.row.getIsExpanded() ? 'v' : '>' }}
                  <FlexRender :cell="cell" />
                  ({{ cell.row.subRows.length.toLocaleString() }})
                </button>
              </template>
              <FlexRender v-else :cell="cell" />
            </td>
          </tr>
          <tr
            v-for="row in table.getBottomRows()"
            :key="row.id"
            class="pinned-row"
            :style="rowStyle(row)"
          >
            <td
              v-for="cell in row.getVisibleCells()"
              :key="cell.id"
              :style="cellStyle(cell)"
              :class="cellClass(cell)"
            >
              <FlexRender :cell="cell" />
            </td>
          </tr>
        </tbody>
      </table>
    </div>

    <div class="spacer-sm" />
    <div class="controls">
      <button
        class="demo-button demo-button-sm"
        @click="table.setPageIndex(0)"
        :disabled="!table.getCanPreviousPage()"
      >
        &lt;&lt;
      </button>
      <button
        class="demo-button demo-button-sm"
        @click="table.previousPage()"
        :disabled="!table.getCanPreviousPage()"
      >
        &lt;
      </button>
      <button
        class="demo-button demo-button-sm"
        @click="table.nextPage()"
        :disabled="!table.getCanNextPage()"
      >
        &gt;
      </button>
      <button
        class="demo-button demo-button-sm"
        @click="table.setPageIndex(table.getPageCount() - 1)"
        :disabled="!table.getCanNextPage()"
      >
        &gt;&gt;
      </button>
      <span class="inline-controls">
        <div>Page</div>
        <strong>
          {{ (table.atoms.pagination.get().pageIndex + 1).toLocaleString() }} of
          {{ table.getPageCount().toLocaleString() }}
        </strong>
      </span>
      <span class="inline-controls">
        | Go to page:
        <input
          type="number"
          min="1"
          :max="table.getPageCount()"
          :value="table.atoms.pagination.get().pageIndex + 1"
          @input="
            table.setPageIndex(
              ($event.target as HTMLInputElement).value
                ? Number(($event.target as HTMLInputElement).value) - 1
                : 0,
            )
          "
          class="page-size-input"
        />
      </span>
      <select
        :value="table.atoms.pagination.get().pageSize"
        @change="
          table.setPageSize(Number(($event.target as HTMLSelectElement).value))
        "
      >
        <option
          v-for="pageSize in [10, 20, 30, 50, 100]"
          :key="pageSize"
          :value="pageSize"
        >
          Show {{ pageSize }}
        </option>
      </select>
    </div>
    <div class="spacer-sm" />
    <div class="nowrap">
      {{ table.getRowModel().rows.length.toLocaleString() }} rows on this page
      ({{ table.getFilteredRowModel().rows.length.toLocaleString() }} filtered
      of {{ table.getCoreRowModel().rows.length.toLocaleString() }} total)
    </div>
    <div class="spacer-md" />
    <details>
      <summary>Table state (live)</summary>
      <pre class="state-dump">{{
        JSON.stringify(table.store.get(), null, 2)
      }}</pre>
    </details>
  </div>
</template>